(* Mathematica Test File *)

(*	PART I - Set
*)
Test[
	(QASet[Commutator[Operator[A], Commutator[Operator[B], Operator[C]]] = Operator[D]];
	Commutator[Operator[A], Commutator[Operator[B], Operator[C]]] === Operator[D] &&
	Commutator[Operator[A], Commutator[Operator[C], Operator[B]]] === -Operator[D] &&
	Commutator[Commutator[Operator[B], Operator[C]], Operator[A]] === -Operator[D] &&
	Commutator[Commutator[Operator[C], Operator[B]], Operator[A]] === Operator[D]),
	True,
	TestID->"Set-20160702-B5T8D9"
]

Test[
	(QAClear[Unset[Commutator[Operator[A], Commutator[Operator[B], Operator[C]]]]];
	Commutator[Operator[A], Commutator[Operator[B], Operator[C]]] === Operator[D]),
	False,
	TestID->"Set-20160702-T4D0P2"
]

Test[
	(QASet[Commutator[Operator[A], Operator[B]] = Operator[D]];
	Commutator[Operator[A], Operator[B]] === Operator[D] &&
	Commutator[Operator[B], Operator[A]] === -Operator[D]),
	True,
	TestID->"Set-20160702-D4L3A2"
]

Test[
	(QAClear[Unset[Commutator[Operator[A], Operator[B]]]];
	Commutator[Operator[A], Operator[B]] === Operator[D]),
	False,
	TestID->"Set-20160702-V9Z3N1"
]

Test[
	(QASet[Commutator[Operator[A], Operator[D]] = 0];
	QASet[Commutator[Operator[B], Operator[D]] = 0];
	QASet[Commutator[Operator[A], Operator[B]] = Operator[D]];
	Commutator[Operator[A]^2, Operator[B]^2] === 
		Sum[Binomial[2, k] (2! / (2 - k)!) (Operator[D]^k) ** Operator[B]^(2 - k) ** Operator[A]^(2 - k), {k, 1, 2}] &&
	Commutator[Operator[B]^2, Operator[A]^2] === 
		Sum[Binomial[2, k] (2! / (2 - k)!) ((-1)^k) (Operator[D]^k) ** Operator[A]^(2 - k) ** Operator[B]^(2 - k), {k, 1, 2}] &&
	Commutator[Operator[A], Exp[I \[HBar] Operator[B]]] === I \[HBar] Operator[D] ** Exp[I \[HBar] Operator[B]] &&
	Commutator[Exp[I \[HBar] Operator[A]], Operator[B]] === I \[HBar] Operator[D] ** Exp[I \[HBar] Operator[A]]),
	True,
	TestID->"Set-20160702-V5H4F2"
]

Test[
	(QAClear[Unset[Commutator[Operator[A], Operator[B]]]];
	QAClear[Unset[Commutator[Operator[A], Operator[D]]]];
	QAClear[Unset[Commutator[Operator[B], Operator[D]]]];
	Commutator[Operator[A]^2, Operator[B]^2] === 
		Sum[Binomial[2, k] (2! / (2 - k)!) (Operator[D]^k) ** Operator[B]^(2 - k) ** Operator[A]^(2 - k), {k, 1, 2}]),
	False,
	TestID->"Set-20160702-X7I1Q7"
]
		
Test[
	(QASet[Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[P], Operator[Q]]] = (I \[HBar])];
	Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[P], Operator[Q]]] === (I \[HBar]) &&
	Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[Q], Operator[P]]] === (-I \[HBar]) &&
	Commutator[Commutator[Operator[B], Operator[A]], Commutator[Operator[P], Operator[Q]]] === (-I \[HBar]) &&
	Commutator[Commutator[Operator[B], Operator[A]], Commutator[Operator[Q], Operator[P]]] === (I \[HBar]) &&
	Commutator[Commutator[Operator[P], Operator[Q]], Commutator[Operator[A], Operator[B]]] === (-I \[HBar]) &&
	Commutator[Commutator[Operator[Q], Operator[P]], Commutator[Operator[A], Operator[B]]] === (I \[HBar]) &&
	Commutator[Commutator[Operator[P], Operator[Q]], Commutator[Operator[B], Operator[A]]] === (I \[HBar]) &&
	Commutator[Commutator[Operator[Q], Operator[P]], Commutator[Operator[B], Operator[A]]] === (-I \[HBar])),
	True,
	TestID->"Set-20160702-I6H8C5"
]

Test[
	(QAClear[Unset[Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[P], Operator[Q]]]]];
	Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[P], Operator[Q]]] === I \[HBar]),
	False,
	TestID->"Set-20160702-I1I4N2"
]

Test[
	(QASet[Commutator[Operator[A], Operator[B]] = 0];
	Commutator[Operator[A], Operator[B]] === 0 &&
	Commutator[Operator[B], Operator[A]] === 0 &&
	Commutator[Sin[Operator[A]], Operator[B]] === 0 &&
	Commutator[Operator[B], Cos[Operator[A]]] === 0 &&
	Commutator[Operator[A], Exp[Operator[B]]] === 0 &&
	Commutator[Log[Operator[B]], Operator[A]] === 0 &&
	Commutator[Sin[Operator[A]], Cos[Operator[B]]] === 0 &&
	Commutator[Exp[I \[HBar] Operator[B]], Exp[Operator[A]]] === 0
	),
	True,
	TestID->"Set-20160702-N3H8Y9"
]

Test[
	(QAClear[Unset[Commutator[Operator[A], Operator[B]]]];
	Commutator[Operator[A], Operator[B]] === 0),
	False,
	TestID->"Set-20160702-J2T3X0"
]

Test[
	(QASet[
		Commutator[Operator[P], Commutator[Operator[P], Operator[Q]]] = 0,
		Commutator[Operator[Q], Commutator[Operator[P], Operator[Q]]] = 0
	];
	Commutator[Operator[P], Commutator[Operator[P], Operator[Q]]] === 0 &&
	Commutator[Operator[P], Commutator[Operator[Q], Operator[P]]] === 0 &&
	Commutator[Commutator[Operator[P], Operator[Q]], Operator[P]] === 0 &&
	Commutator[Commutator[Operator[Q], Operator[P]], Operator[P]] === 0 &&
	Commutator[Operator[Q], Commutator[Operator[P], Operator[Q]]] === 0 &&
	Commutator[Operator[Q], Commutator[Operator[Q], Operator[P]]] === 0 &&
	Commutator[Commutator[Operator[P], Operator[Q]], Operator[Q]] === 0 &&
	Commutator[Commutator[Operator[Q], Operator[P]], Operator[Q]] === 0 &&
	Commutator[Operator[P]^2, Operator[Q]^2] ===
		Sum[Binomial[2, k] (2! / (2 - k)!) (Commutator[Operator[P],Operator[Q]]^k) ** Operator[Q]^(2-k) ** Operator[P]^(2-k), {k, 1, 2}] &&
	Commutator[Operator[Q]^2, Operator[P]^2] ===
		Sum[Binomial[2, k] (2! / (2 - k)!) ((-1)^k) (Commutator[Operator[P],Operator[Q]]^k) ** Operator[P]^(2-k) ** Operator[Q]^(2-k), {k, 1, 2}] &&
	Commutator[Operator[P], Exp[Operator[Q]]] === Commutator[Operator[P], Operator[Q]] ** Exp[Operator[Q]] &&  
	Commutator[Sin[Operator[P]], Operator[Q]] === Commutator[Operator[P], Operator[Q]] ** Cos[Operator[P]]  
	),
	True,
	TestID->"Set-20160702-Z0Z3I3"
]

Test[
	(QAClear[
		Unset[Commutator[Operator[P], Commutator[Operator[P], Operator[Q]]]],
		Unset[Commutator[Operator[Q], Commutator[Operator[P], Operator[Q]]]]
	];
	Commutator[Operator[P], Commutator[Operator[P], Operator[Q]]] === 0),
	False,
	TestID->"Set-20160702-C9G4F0"
]

Test[
	(QASet[Operator[P] ** Ket[m_] = c1 Ket[m - 1]];
	Operator[P] ** Ket[j] === c1 Ket[j - 1] &&
	Bra[j] ** Operator[P, "H"] === Conjugate[c1] Bra[j - 1]),
	True,
	TestID->"Set-20160702-F3S1C5"
]

Test[
	(QAClear[Unset[Operator[P] ** Ket[m_]]];
	Operator[P] ** Ket[j] === c1 Ket[j - 1]),
	False,
	TestID->"Set-20160702-T2G3B6"
]

Test[
	(QASet[Operator[P] ** Ket[m_] = c1 Ket[m]];
	Operator[P] ** Ket[j] === c1 Ket[j] &&
	Bra[j] ** Operator[P, "H"] === Conjugate[c1] Bra[j] &&
	Exp[Operator[P]] ** Ket[j] === Exp[c1] Ket[j] &&
	Bra[j] ** Exp[Operator[P, "H"]] === Exp[Conjugate[c1]] Bra[j]
	),
	True,
	TestID->"Set-20160702-F7V8T3"
]

Test[
	(QAClear[Unset[Operator[P] ** Ket[m_]]];
	Operator[P] ** Ket[j] === c1 Ket[j]),
	False,
	TestID->"Set-20160702-E8M7E1"
]

Test[
	(QASet[Bra[x_] ** Operator[p] ** Ket[n_] = (D[#1, #2])&];
	Bra[x] ** Operator[p] ** Ket[n]),
	D[BraKet[{x}, {n}], x],
	TestID->"Set-20160703-I6V7U7"
]

Test[
	(QAClear[Unset[Bra[x_] ** Operator[p] ** Ket[n_]]];
	Bra[x] ** Operator[p] ** Ket[n] === D[BraKet[{x}, {n}], x]),
	False,
	TestID->"Set-20160703-F1H6P6"
]


(*	PART II - SetDelayed
*)
Test[
	(QASet[Commutator[Operator[A], Commutator[Operator[B], Operator[C]]] := Operator[D]];
	Commutator[Operator[A], Commutator[Operator[B], Operator[C]]] === Operator[D] &&
	Commutator[Operator[A], Commutator[Operator[C], Operator[B]]] === -Operator[D] &&
	Commutator[Commutator[Operator[B], Operator[C]], Operator[A]] === -Operator[D] &&
	Commutator[Commutator[Operator[C], Operator[B]], Operator[A]] === Operator[D]),
	True,
	TestID->"Set-20160703-T8U9L3"
]

Test[
	(QAClear[Unset[Commutator[Operator[A], Commutator[Operator[B], Operator[C]]]]];
	Commutator[Operator[A], Commutator[Operator[B], Operator[C]]] === Operator[D]),
	False,
	TestID->"Set-20160703-R9W3A9"
]

Test[
	(QASet[Commutator[Operator[A], Operator[B]] := Operator[D]];
	Commutator[Operator[A], Operator[B]] === Operator[D] &&
	Commutator[Operator[B], Operator[A]] === -Operator[D]),
	True,
	TestID->"Set-20160703-A5E2A8"
]

Test[
	(QAClear[Unset[Commutator[Operator[A], Operator[B]]]];
	Commutator[Operator[A], Operator[B]] === Operator[D]),
	False,
	TestID->"Set-20160703-Z2V3S2"
]

Test[
	(QASet[Commutator[Operator[A], Operator[D]] := 0];
	QASet[Commutator[Operator[B], Operator[D]] := 0];
	QASet[Commutator[Operator[A], Operator[B]] := Operator[D]];
	Commutator[Operator[A]^2, Operator[B]^2] === 
		Sum[Binomial[2, k] (2! / (2 - k)!) (Operator[D]^k) ** Operator[B]^(2 - k) ** Operator[A]^(2 - k), {k, 1, 2}] &&
	Commutator[Operator[B]^2, Operator[A]^2] === 
		Sum[Binomial[2, k] (2! / (2 - k)!) ((-1)^k) (Operator[D]^k) ** Operator[A]^(2 - k) ** Operator[B]^(2 - k), {k, 1, 2}] &&
	Commutator[Operator[A], Exp[I \[HBar] Operator[B]]] === I \[HBar] Operator[D] ** Exp[I \[HBar] Operator[B]] &&
	Commutator[Exp[I \[HBar] Operator[A]], Operator[B]] === I \[HBar] Operator[D] ** Exp[I \[HBar] Operator[A]]),
	True,
	TestID->"Set-20160703-F5T0V2"
]

Test[
	(QAClear[Unset[Commutator[Operator[A], Operator[B]]]];
	QAClear[Unset[Commutator[Operator[A], Operator[D]]]];
	QAClear[Unset[Commutator[Operator[B], Operator[D]]]];
	Commutator[Operator[A]^2, Operator[B]^2] === 
		Sum[Binomial[2, k] (2! / (2 - k)!) (Operator[D]^k) ** Operator[B]^(2 - k) ** Operator[A]^(2 - k), {k, 1, 2}]),
	False,
	TestID->"Set-20160703-Q8Q2K2"
]
		
Test[
	(QASet[Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[P], Operator[Q]]] := (I \[HBar])];
	Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[P], Operator[Q]]] === (I \[HBar]) &&
	Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[Q], Operator[P]]] === (-I \[HBar]) &&
	Commutator[Commutator[Operator[B], Operator[A]], Commutator[Operator[P], Operator[Q]]] === (-I \[HBar]) &&
	Commutator[Commutator[Operator[B], Operator[A]], Commutator[Operator[Q], Operator[P]]] === (I \[HBar]) &&
	Commutator[Commutator[Operator[P], Operator[Q]], Commutator[Operator[A], Operator[B]]] === (-I \[HBar]) &&
	Commutator[Commutator[Operator[Q], Operator[P]], Commutator[Operator[A], Operator[B]]] === (I \[HBar]) &&
	Commutator[Commutator[Operator[P], Operator[Q]], Commutator[Operator[B], Operator[A]]] === (I \[HBar]) &&
	Commutator[Commutator[Operator[Q], Operator[P]], Commutator[Operator[B], Operator[A]]] === (-I \[HBar])),
	True,
	TestID->"Set-20160703-B7P7I8"
]

Test[
	(QAClear[Unset[Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[P], Operator[Q]]]]];
	Commutator[Commutator[Operator[A], Operator[B]], Commutator[Operator[P], Operator[Q]]] === I \[HBar]),
	False,
	TestID->"Set-20160703-O8V9N1"
]

Test[
	(QASet[Commutator[Operator[A], Operator[B]] := 0];
	Commutator[Operator[A], Operator[B]] === 0 &&
	Commutator[Operator[B], Operator[A]] === 0 &&
	Commutator[Sin[Operator[A]], Operator[B]] === 0 &&
	Commutator[Operator[B], Cos[Operator[A]]] === 0 &&
	Commutator[Operator[A], Exp[Operator[B]]] === 0 &&
	Commutator[Log[Operator[B]], Operator[A]] === 0 &&
	Commutator[Sin[Operator[A]], Cos[Operator[B]]] === 0 &&
	Commutator[Exp[I \[HBar] Operator[B]], Exp[Operator[A]]] === 0
	),
	True,
	TestID->"Set-20160703-H7D5J7"
]

Test[
	(QAClear[Unset[Commutator[Operator[A], Operator[B]]]];
	Commutator[Operator[A], Operator[B]] === 0),
	False,
	TestID->"Set-20160703-U9X8J0"
]

Test[
	(QASet[
		Commutator[Operator[P], Commutator[Operator[P], Operator[Q]]] := 0,
		Commutator[Operator[Q], Commutator[Operator[P], Operator[Q]]] := 0
	];
	Commutator[Operator[P], Commutator[Operator[P], Operator[Q]]] === 0 &&
	Commutator[Operator[P], Commutator[Operator[Q], Operator[P]]] === 0 &&
	Commutator[Commutator[Operator[P], Operator[Q]], Operator[P]] === 0 &&
	Commutator[Commutator[Operator[Q], Operator[P]], Operator[P]] === 0 &&
	Commutator[Operator[Q], Commutator[Operator[P], Operator[Q]]] === 0 &&
	Commutator[Operator[Q], Commutator[Operator[Q], Operator[P]]] === 0 &&
	Commutator[Commutator[Operator[P], Operator[Q]], Operator[Q]] === 0 &&
	Commutator[Commutator[Operator[Q], Operator[P]], Operator[Q]] === 0 &&
	Commutator[Operator[P]^2, Operator[Q]^2] ===
		Sum[Binomial[2, k] (2! / (2 - k)!) (Commutator[Operator[P],Operator[Q]]^k) ** Operator[Q]^(2-k) ** Operator[P]^(2-k), {k, 1, 2}] &&
	Commutator[Operator[Q]^2, Operator[P]^2] ===
		Sum[Binomial[2, k] (2! / (2 - k)!) ((-1)^k) (Commutator[Operator[P],Operator[Q]]^k) ** Operator[P]^(2-k) ** Operator[Q]^(2-k), {k, 1, 2}] &&
	Commutator[Operator[P], Exp[Operator[Q]]] === Commutator[Operator[P], Operator[Q]] ** Exp[Operator[Q]] &&  
	Commutator[Sin[Operator[P]], Operator[Q]] === Commutator[Operator[P], Operator[Q]] ** Cos[Operator[P]]  
	),
	True,
	TestID->"Set-20160703-B5Y2U3"
]

Test[
	(QAClear[
		Unset[Commutator[Operator[P], Commutator[Operator[P], Operator[Q]]]],
		Unset[Commutator[Operator[Q], Commutator[Operator[P], Operator[Q]]]]
	];
	Commutator[Operator[P], Commutator[Operator[P], Operator[Q]]] === 0),
	False,
	TestID->"Set-20160703-L3O0E4"
]

Test[
	(QASet[Operator[P] ** Ket[m_] := c1 Ket[m - 1]];
	Operator[P] ** Ket[j] === c1 Ket[j - 1] &&
	Bra[j] ** Operator[P, "H"] === Conjugate[c1] Bra[j - 1]),
	True,
	TestID->"Set-20160703-R4B2H4"
]

Test[
	(QAClear[Unset[Operator[P] ** Ket[m_]]];
	Operator[P] ** Ket[j] === c1 Ket[j - 1]),
	False,
	TestID->"Set-20160703-J9G5W0"
]

Test[
	(QASet[Operator[P] ** Ket[m_] := c1 Ket[m]];
	Operator[P] ** Ket[j] === c1 Ket[j] &&
	Bra[j] ** Operator[P, "H"] === Conjugate[c1] Bra[j] &&
	Exp[Operator[P]] ** Ket[j] === Exp[c1] Ket[j] &&
	Bra[j] ** Exp[Operator[P, "H"]] === Exp[Conjugate[c1]] Bra[j]
	),
	True,
	TestID->"Set-20160703-U6B5Y1"
]

Test[
	(QAClear[Unset[Operator[P] ** Ket[m_]]];
	Operator[P] ** Ket[j] === c1 Ket[j]),
	False,
	TestID->"Set-20160703-E7E7L4"
]

Test[
	(QASet[Bra[x_] ** Operator[p] ** Ket[n_] := (D[#1, #2])&];
	Bra[x] ** Operator[p] ** Ket[n]),
	D[BraKet[{x}, {n}], x],
	TestID->"Set-20160703-D5A8T1"
]

Test[
	(QAClear[Unset[Bra[x_] ** Operator[p] ** Ket[n_]]];
	Bra[x] ** Operator[p] ** Ket[n] === D[BraKet[{x}, {n}], x]),
	False,
	TestID->"Set-20160703-F9N4R3"
]

