(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     30108,       1030]
NotebookOptionsPosition[     20034,        746]
NotebookOutlinePosition[     24130,        842]
CellTagsIndexPosition[     24087,        839]
WindowTitle->Quantum Algebra Overview
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE OVERVIEW", "PacletNameCell"], Cell[TextData[
    Cell[BoxData[
     ActionMenuBox[
      FrameBox[
       InterpretationBox[Cell[TextData[{
         "URL",
         StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
          StripOnInput->False]
        }]],
        TextCell[
         Row[{"URL", 
           Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
       StripOnInput->False], {"\<\"QuantumAlgebra/guide/Contents\"\>":>
      None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["QuantumAlgebra/guide/Contents"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/language/QuantumAlgebra/guide/\
Contents.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
           Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
            If[
             TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$4047], 
             "http://reference.wolfram.com/system-modeler/", 
             "http://reference.wolfram.com/language/"], 
            "QuantumAlgebra/guide/Contents", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic,
      MenuStyle->"URLMenu"]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Quantum Algebra Overview", "TOCDocumentTitle"],

Cell[CellGroupData[{

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Basics"]],"paclet:QuantumAlgebra/tutorial/Basics#509267359"},
  "RefLink",
  BaseStyle->"TOCChapter"]], "TOCChapter"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Preparation of a Session"]],
   "paclet:QuantumAlgebra/tutorial/Basics#65243614"},
  "RefLink",
  BaseStyle->{"TOCSection", "TOCSection"}]], "TOCSection",
 CellID->13021204],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Provide Required Input"]],
   "paclet:QuantumAlgebra/tutorial/Basics#934999218"},
  "RefLink",
  BaseStyle->"TOCSection"]], "TOCSection"],

Cell[CellGroupData[{

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["A Few Simple Calculations"]],
   "paclet:QuantumAlgebra/tutorial/Basics#587363850"},
  "RefLink",
  BaseStyle->"TOCSection"]], "TOCSection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Orthonormalized BraKet Sample"]],
   "paclet:QuantumAlgebra/tutorial/Basics#33620847"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["The Harmonic Oscillator Sample"]],
   "paclet:QuantumAlgebra/tutorial/Basics#30976998"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->321693044]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Reference Pages/Symbols"]],"paclet:QuantumAlgebra/ref/Bra"},
  "RefLink",
  BaseStyle->"TOCChapter"]], "TOCChapter"],

Cell[CellGroupData[{

Cell["Core", "TOCSection",
 CellID->377286030],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["BCHRelation"]],"paclet:QuantumAlgebra/ref/BCHRelation"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->342939551],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Bra"]],"paclet:QuantumAlgebra/ref/Bra"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["BraQ"]],"paclet:QuantumAlgebra/ref/BraQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->32433960],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["BraKet"]],"paclet:QuantumAlgebra/ref/BraKet"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->351382704],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["ConstantQ"]],"paclet:QuantumAlgebra/ref/ConstantQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Hermitian"]],"paclet:QuantumAlgebra/ref/Hermitian"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Ket"]],"paclet:QuantumAlgebra/ref/Ket"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["KetQ"]],"paclet:QuantumAlgebra/ref/KetQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Operator"]],"paclet:QuantumAlgebra/ref/Operator"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["OperatorQ"]],"paclet:QuantumAlgebra/ref/OperatorQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAClear"]],"paclet:QuantumAlgebra/ref/QAClear"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->578287511],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QACommutatorContract"]],
   "paclet:QuantumAlgebra/ref/QACommutatorContract"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->395327052],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QACommutatorExpand"]],
   "paclet:QuantumAlgebra/ref/QACommutatorExpand"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->525921819],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAExpandAll"]],"paclet:QuantumAlgebra/ref/QAExpandAll"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->111552407],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAOrdering"]],"paclet:QuantumAlgebra/ref/QAOrdering"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->13159777],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAPowerContract"]],"paclet:QuantumAlgebra/ref/QAPowerContract"},
  
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->12744903],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAPowerExpand"]],"paclet:QuantumAlgebra/ref/QAPowerExpand"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->576781600],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAProductExpand"]],"paclet:QuantumAlgebra/ref/QAProductExpand"},
  
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->432326754],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASeries"]],"paclet:QuantumAlgebra/ref/QASeries"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->146593112],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASet"]],"paclet:QuantumAlgebra/ref/QASet"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->85905925],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["SetNotebookStyles"]],
   "paclet:QuantumAlgebra/ref/SetNotebookStyles"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->44479272]
}, Open  ]],

Cell[CellGroupData[{

Cell["Analyze", "TOCSection",
 CellID->79214956],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Analyze"]],"paclet:QuantumAlgebra/ref/Analyze"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->273308043],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["BraExpressionQ"]],"paclet:QuantumAlgebra/ref/BraExpressionQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->182219263],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["CommutatorExpressionQ"]],
   "paclet:QuantumAlgebra/ref/CommutatorExpressionQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->32658359],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["ConstantExpressionQ"]],
   "paclet:QuantumAlgebra/ref/ConstantExpressionQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->537458256],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["KetExpressionQ"]],"paclet:QuantumAlgebra/ref/KetExpressionQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->211314788],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["OperatorExpressionQ"]],
   "paclet:QuantumAlgebra/ref/OperatorExpressionQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->361105577],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QuantumConstantExpressionQ"]],
   "paclet:QuantumAlgebra/ref/QuantumConstantExpressionQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->94206047],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QuantumExpressionQ"]],
   "paclet:QuantumAlgebra/ref/QuantumExpressionQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->25025470],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QuantumFreeQ"]],"paclet:QuantumAlgebra/ref/QuantumFreeQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->89468400],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["SimpleConstantExpressionQ"]],
   "paclet:QuantumAlgebra/ref/SimpleConstantExpressionQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->34116352]
}, Open  ]],

Cell[CellGroupData[{

Cell["Supplement", "TOCSection",
 CellID->1993924],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["ColumnQ"]],"paclet:QuantumAlgebra/ref/ColumnQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->144569133],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DefineCommutatorRule"]],
   "paclet:QuantumAlgebra/ref/DefineCommutatorRule"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->23086651],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DefineNameOrderingRule"]],
   "paclet:QuantumAlgebra/ref/DefineNameOrderingRule"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->470592732],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Factorise"]],"paclet:QuantumAlgebra/ref/Factorise"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->23058134],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["MakeColumn"]],"paclet:QuantumAlgebra/ref/MakeColumn"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->341717183],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["MakeRow"]],"paclet:QuantumAlgebra/ref/MakeRow"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->235391968],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAD"]],"paclet:QuantumAlgebra/ref/QAD"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->118603698],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAFullSimplify"]],"paclet:QuantumAlgebra/ref/QAFullSimplify"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->8396761],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAInitializeReplacementRules"]],
   "paclet:QuantumAlgebra/ref/QAInitializeReplacementRules"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->603168601],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAIntegrate"]],"paclet:QuantumAlgebra/ref/QAIntegrate"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->158598454],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASimplescript"]],"paclet:QuantumAlgebra/ref/QASimplescript"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->400584464],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASimplify"]],"paclet:QuantumAlgebra/ref/QASimplify"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->4048513],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASubsuperscript"]],
   "paclet:QuantumAlgebra/ref/QASubsuperscript"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->136394767],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASum"]],"paclet:QuantumAlgebra/ref/QASum"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->119190252],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["RowQ"]],"paclet:QuantumAlgebra/ref/RowQ"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->753523811]
}, Open  ]],

Cell[CellGroupData[{

Cell["Agreements", "TOCSection",
 CellID->98955778],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAReset"]],"paclet:QuantumAlgebra/ref/QAReset"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->259073416],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASelectDefault"]],"paclet:QuantumAlgebra/ref/QASelectDefault"},
  
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->192565015],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAGetDefault"]],"paclet:QuantumAlgebra/ref/QAGetDefault"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->65924636],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAResetAssumptions"]],
   "paclet:QuantumAlgebra/ref/QAResetAssumptions"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->92849867],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAAddAssumptions"]],
   "paclet:QuantumAlgebra/ref/QAAddAssumptions"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->107068613],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAGetAssumptions"]],
   "paclet:QuantumAlgebra/ref/QAGetAssumptions"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->319844459],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAResetExplicitIntegrationVariables"]],
   "paclet:QuantumAlgebra/ref/QAResetExplicitIntegrationVariables"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->184577546],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAAddExplicitIntegrationVariables"]],
   "paclet:QuantumAlgebra/ref/QAAddExplicitIntegrationVariables"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->26275687],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAGetExplicitIntegrationVariables"]],
   "paclet:QuantumAlgebra/ref/QAGetExplicitIntegrationVariables"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->383181637],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAResetNotScriptedSymbols"]],
   "paclet:QuantumAlgebra/ref/QAResetNotScriptedSymbols"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->272388617],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAAddNotScriptedSymbols"]],
   "paclet:QuantumAlgebra/ref/QAAddNotScriptedSymbols"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->464080591],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAGetNotScriptedSymbols"]],
   "paclet:QuantumAlgebra/ref/QAGetNotScriptedSymbols"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->69210587],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAResetReplacementRules"]],
   "paclet:QuantumAlgebra/ref/QAResetReplacementRules"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->74470877],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAAddReplacementRules"]],
   "paclet:QuantumAlgebra/ref/QAAddReplacementRules"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->137491482],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAGetReplacementRules"]],
   "paclet:QuantumAlgebra/ref/QAGetReplacementRules"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->84845572],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASetIndexCharacter"]],
   "paclet:QuantumAlgebra/ref/QASetIndexCharacter"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->141264287],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAGetIndexCharacter"]],
   "paclet:QuantumAlgebra/ref/QAGetIndexCharacter"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->110060189],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASetTimeConstraint"]],
   "paclet:QuantumAlgebra/ref/QASetTimeConstraint"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->155379549],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAGetTimeConstraint"]],
   "paclet:QuantumAlgebra/ref/QAGetTimeConstraint"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->153367324]
}, Open  ]],

Cell[CellGroupData[{

Cell["Options", "TOCSection",
 CellID->338187459],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAOptions"]],"paclet:QuantumAlgebra/ref/QAOptions"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->721849837],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QAPrint"]],"paclet:QuantumAlgebra/ref/QAPrint"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->135591226],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASniff"]],"paclet:QuantumAlgebra/ref/QASniff"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->549174109],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QATiming"]],"paclet:QuantumAlgebra/ref/QATiming"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->14481440],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["PrtLevel"]],"paclet:QuantumAlgebra/ref/PrtLevel"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->422349493],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Verbosity"]],"paclet:QuantumAlgebra/ref/Verbosity"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->77569450]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Guides"]],"paclet:QuantumAlgebra/guide/Guide"},
  "RefLink",
  BaseStyle->"TOCChapter"]], "TOCChapter"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Guide"]],"paclet:QuantumAlgebra/guide/Guide"},
  "RefLink",
  BaseStyle->"TOCSection"]], "TOCSection"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Packages"]],"paclet:QuantumAlgebra/guide/Packages"},
  "RefLink",
  BaseStyle->"TOCSection"]], "TOCSection",
 CellID->323917010],

Cell[CellGroupData[{

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Input"]],"paclet:QuantumAlgebra/guide/Input"},
  "RefLink",
  BaseStyle->"TOCSection"]], "TOCSection",
 CellID->3411059],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Input Aliases"]],"paclet:QuantumAlgebra/guide/InputAliases"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->7284636],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Palette Input"]],"paclet:QuantumAlgebra/guide/PaletteInput"},
  "RefLink",
  BaseStyle->"TOCSubsection"]], "TOCSubsection",
 CellID->139125057]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Quantum Algebra Overview",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "TutorialColor", 
  "LinkTrails" -> GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 22.6495031}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Overview", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "Basics Reference Pages/Symbols Guides", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$3917, "title" -> 
    "Quantum Algebra Overview", "titlemodifier" -> "", "windowtitle" -> 
    "Quantum Algebra Overview", "type" -> "Overview", "uri" -> 
    "QuantumAlgebra/guide/Contents"}, "SearchTextTranslated" -> ""},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TOCSubsubsection"], 
    CellGroupingRules -> {"SectionGrouping", 69}], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 2323, 54, 50, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2944, 79, 52, 0, 56, "TOCDocumentTitle"],
Cell[CellGroupData[{
Cell[3021, 83, 165, 4, 47, "TOCChapter"],
Cell[3189, 89, 221, 6, 28, "TOCSection",
 CellID->13021204],
Cell[3413, 97, 185, 5, 22, "TOCSection"],
Cell[CellGroupData[{
Cell[3623, 106, 188, 5, 22, "TOCSection"],
Cell[3814, 113, 197, 5, 19, "TOCSubsection"],
Cell[4014, 120, 218, 6, 19, "TOCSubsection",
 CellID->321693044]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4281, 132, 164, 4, 47, "TOCChapter"],
Cell[CellGroupData[{
Cell[4470, 140, 46, 1, 26, "TOCSection",
 CellID->377286030],
Cell[4519, 143, 186, 5, 19, "TOCSubsection",
 CellID->342939551],
Cell[4708, 150, 150, 4, 19, "TOCSubsection"],
Cell[4861, 156, 171, 5, 19, "TOCSubsection",
 CellID->32433960],
Cell[5035, 163, 156, 4, 19, "TOCSubsection"],
Cell[5194, 169, 184, 5, 19, "TOCSubsection",
 CellID->351382704],
Cell[5381, 176, 162, 4, 19, "TOCSubsection"],
Cell[5546, 182, 162, 4, 19, "TOCSubsection"],
Cell[5711, 188, 150, 4, 19, "TOCSubsection"],
Cell[5864, 194, 152, 4, 19, "TOCSubsection"],
Cell[6019, 200, 160, 4, 19, "TOCSubsection"],
Cell[6182, 206, 162, 4, 19, "TOCSubsection"],
Cell[6347, 212, 178, 5, 19, "TOCSubsection",
 CellID->578287511],
Cell[6528, 219, 208, 6, 19, "TOCSubsection",
 CellID->395327052],
Cell[6739, 227, 204, 6, 19, "TOCSubsection",
 CellID->525921819],
Cell[6946, 235, 186, 5, 19, "TOCSubsection",
 CellID->111552407],
Cell[7135, 242, 183, 5, 19, "TOCSubsection",
 CellID->13159777],
Cell[7321, 249, 196, 6, 19, "TOCSubsection",
 CellID->12744903],
Cell[7520, 257, 190, 5, 19, "TOCSubsection",
 CellID->576781600],
Cell[7713, 264, 197, 6, 19, "TOCSubsection",
 CellID->432326754],
Cell[7913, 272, 180, 5, 19, "TOCSubsection",
 CellID->146593112],
Cell[8096, 279, 173, 5, 19, "TOCSubsection",
 CellID->85905925],
Cell[8272, 286, 201, 6, 70, "TOCSubsection",
 CellID->44479272]
}, Open  ]],
Cell[CellGroupData[{
Cell[8510, 297, 48, 1, 70, "TOCSection",
 CellID->79214956],
Cell[8561, 300, 178, 5, 70, "TOCSubsection",
 CellID->273308043],
Cell[8742, 307, 192, 5, 70, "TOCSubsection",
 CellID->182219263],
Cell[8937, 314, 209, 6, 70, "TOCSubsection",
 CellID->32658359],
Cell[9149, 322, 206, 6, 70, "TOCSubsection",
 CellID->537458256],
Cell[9358, 330, 192, 5, 70, "TOCSubsection",
 CellID->211314788],
Cell[9553, 337, 206, 6, 70, "TOCSubsection",
 CellID->361105577],
Cell[9762, 345, 219, 6, 70, "TOCSubsection",
 CellID->94206047],
Cell[9984, 353, 203, 6, 70, "TOCSubsection",
 CellID->25025470],
Cell[10190, 361, 187, 5, 70, "TOCSubsection",
 CellID->89468400],
Cell[10380, 368, 217, 6, 70, "TOCSubsection",
 CellID->34116352]
}, Open  ]],
Cell[CellGroupData[{
Cell[10634, 379, 50, 1, 70, "TOCSection",
 CellID->1993924],
Cell[10687, 382, 178, 5, 70, "TOCSubsection",
 CellID->144569133],
Cell[10868, 389, 207, 6, 70, "TOCSubsection",
 CellID->23086651],
Cell[11078, 397, 212, 6, 70, "TOCSubsection",
 CellID->470592732],
Cell[11293, 405, 181, 5, 70, "TOCSubsection",
 CellID->23058134],
Cell[11477, 412, 184, 5, 70, "TOCSubsection",
 CellID->341717183],
Cell[11664, 419, 178, 5, 70, "TOCSubsection",
 CellID->235391968],
Cell[11845, 426, 170, 5, 70, "TOCSubsection",
 CellID->118603698],
Cell[12018, 433, 190, 5, 70, "TOCSubsection",
 CellID->8396761],
Cell[12211, 440, 224, 6, 70, "TOCSubsection",
 CellID->603168601],
Cell[12438, 448, 186, 5, 70, "TOCSubsection",
 CellID->158598454],
Cell[12627, 455, 192, 5, 70, "TOCSubsection",
 CellID->400584464],
Cell[12822, 462, 182, 5, 70, "TOCSubsection",
 CellID->4048513],
Cell[13007, 469, 200, 6, 70, "TOCSubsection",
 CellID->136394767],
Cell[13210, 477, 174, 5, 70, "TOCSubsection",
 CellID->119190252],
Cell[13387, 484, 172, 5, 70, "TOCSubsection",
 CellID->753523811]
}, Open  ]],
Cell[CellGroupData[{
Cell[13596, 494, 51, 1, 70, "TOCSection",
 CellID->98955778],
Cell[13650, 497, 178, 5, 70, "TOCSubsection",
 CellID->259073416],
Cell[13831, 504, 197, 6, 70, "TOCSubsection",
 CellID->192565015],
Cell[14031, 512, 187, 5, 70, "TOCSubsection",
 CellID->65924636],
Cell[14221, 519, 203, 6, 70, "TOCSubsection",
 CellID->92849867],
Cell[14427, 527, 200, 6, 70, "TOCSubsection",
 CellID->107068613],
Cell[14630, 535, 200, 6, 70, "TOCSubsection",
 CellID->319844459],
Cell[14833, 543, 238, 6, 70, "TOCSubsection",
 CellID->184577546],
Cell[15074, 551, 233, 6, 70, "TOCSubsection",
 CellID->26275687],
Cell[15310, 559, 234, 6, 70, "TOCSubsection",
 CellID->383181637],
Cell[15547, 567, 218, 6, 70, "TOCSubsection",
 CellID->272388617],
Cell[15768, 575, 214, 6, 70, "TOCSubsection",
 CellID->464080591],
Cell[15985, 583, 213, 6, 70, "TOCSubsection",
 CellID->69210587],
Cell[16201, 591, 213, 6, 70, "TOCSubsection",
 CellID->74470877],
Cell[16417, 599, 210, 6, 70, "TOCSubsection",
 CellID->137491482],
Cell[16630, 607, 209, 6, 70, "TOCSubsection",
 CellID->84845572],
Cell[16842, 615, 206, 6, 70, "TOCSubsection",
 CellID->141264287],
Cell[17051, 623, 206, 6, 70, "TOCSubsection",
 CellID->110060189],
Cell[17260, 631, 206, 6, 70, "TOCSubsection",
 CellID->155379549],
Cell[17469, 639, 206, 6, 70, "TOCSubsection",
 CellID->153367324]
}, Open  ]],
Cell[CellGroupData[{
Cell[17712, 650, 49, 1, 70, "TOCSection",
 CellID->338187459],
Cell[17764, 653, 182, 5, 70, "TOCSubsection",
 CellID->721849837],
Cell[17949, 660, 178, 5, 70, "TOCSubsection",
 CellID->135591226],
Cell[18130, 667, 178, 5, 70, "TOCSubsection",
 CellID->549174109],
Cell[18311, 674, 179, 5, 70, "TOCSubsection",
 CellID->14481440],
Cell[18493, 681, 180, 5, 70, "TOCSubsection",
 CellID->422349493],
Cell[18676, 688, 181, 5, 70, "TOCSubsection",
 CellID->77569450]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18906, 699, 151, 4, 70, "TOCChapter"],
Cell[19060, 705, 150, 4, 70, "TOCSection"],
Cell[19213, 711, 176, 5, 70, "TOCSection",
 CellID->323917010],
Cell[CellGroupData[{
Cell[19414, 720, 168, 5, 70, "TOCSection",
 CellID->3411059],
Cell[19585, 727, 189, 5, 70, "TOCSubsection",
 CellID->7284636],
Cell[19777, 734, 191, 5, 70, "TOCSubsection",
 CellID->139125057]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[20007, 744, 23, 0, 70, "FooterCell"]
}
]
*)

