(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     13893,        404]
NotebookOptionsPosition[      8997,        282]
NotebookOutlinePosition[     12686,        364]
CellTagsIndexPosition[     12643,        361]
WindowTitle->QuantumAlgebra Guide
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE GUIDE", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Functions",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Functions", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Bra\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Bra"], "\<\"BraKet\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/BraKet"], "\<\"Ket\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Ket"], "\<\"Operator\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/Operator"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideFunction"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Quantum Algebra Packages\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/guide/Packages"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideMoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Tutorials",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Tutorials", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Quantum Algebra Overview\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/guide/Contents"], "\<\"Quantum Algebra Basics\"\
\>":>Documentation`HelpLookup["paclet:QuantumAlgebra/tutorial/Basics"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideTutorial"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/guide/Guide\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/guide/Guide"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/guide/\
Guide.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$4563], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/guide/Guide", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["QuantumAlgebra Guide", "GuideTitle",
 CellID->942062912],

Cell["\<\
This guide contains introductionary information about the Quantum Algebra \
application.\
\>", "GuideAbstract",
 CellID->2001916300]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Reference"
}], "GuideReferenceSection",
 WholeCellGroupOpener->True],

Cell["", "SectionHeaderSpacer"],

Cell[CellGroupData[{

Cell["Quantum Mechanical Base Objects", "GuideFunctionsSubsection",
 CellID->351933073],

Cell["\<\
The symbols listed below serve as Quantum Mechanical base objects. Whereas a \
BraKet is treated as a constant, this is not true for the other objects. The \
latter are non-constants with special treatment. Nevertheless there are \
special cases where a combination of Bra - Operator - Ket is treated as \
constant - for simplification purposes, as in Quantum Theory such a \
combination represents a constant.
Remark: With constant we do not mean a physical constant here but an \
expression which is evaluated to a quantity.\
\>", "GuideText",
 CellID->348045444],

Cell[TextData[{
 ButtonBox["Bra",
  BaseStyle->"Link",
  ButtonData->"paclet:QuantumAlgebra/ref/Bra"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " This symbol signifies the basic Bra object of the Dirac Bra - Ket - \
Notation"
}], "GuideText",
 CellID->203374175],

Cell[TextData[{
 ButtonBox["Ket",
  BaseStyle->"Link",
  ButtonData->"paclet:QuantumAlgebra/ref/Ket"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " This symbol signifies the basic Ket object of the Dirac Bra - Ket - \
Notation"
}], "GuideText",
 CellID->1463276848],

Cell[TextData[{
 ButtonBox["BraKet",
  BaseStyle->"Link",
  ButtonData->"paclet:QuantumAlgebra/ref/BraKet"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " This symbol signifies the basic BraKet object as a result of the \
multiplication of Bra and Ket objects"
}], "GuideText",
 CellID->56750302],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Operator"]],"paclet:QuantumAlgebra/ref/Operator"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " ",
 "This symbol signifies the basic Quantum Mechanical Operator object "
}], "GuideText",
 CellID->769448525],

Cell["\t", "GuideDelimiterSubsection",
 CellID->311258892]
}, Open  ]],

Cell[CellGroupData[{

Cell["Input Possibilities", "GuideFunctionsSubsection",
 CellID->155582371],

Cell["\<\
There are two possibilities to enter Quantum Mechanical base objects: You can \
enter the fullform of the objects or use an input alias. With input alias \
you'll get a two-dimensional template with placeholders, where you can enter \
required information.
Each time when you initiate the Needs command to load the Quantum Algebra \
package, you'll get a printout of the aliases available for input.\
\>", "GuideText",
 CellID->209193518]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Related Guides"
}], "GuideMoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Quantum Algebra Packages"]],
   "paclet:QuantumAlgebra/guide/Packages"},
  "RefLink",
  BaseStyle->"GuideMoreAbout"]], "GuideMoreAbout",
 CellID->1567025153]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QuantumAlgebra Guide",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 25.1917121}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"Bra Ket BraKet Operator Dirac Constant"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Guide", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "This guide contains introductionary information about the Quantum \
Algebra application.", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$4490, "title" -> 
    "QuantumAlgebra Guide", "titlemodifier" -> "", "windowtitle" -> 
    "QuantumAlgebra Guide", "type" -> "Guide", "uri" -> 
    "QuantumAlgebra/guide/Guide"}, "SearchTextTranslated" -> ""},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}]}, Visible -> False, FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 4679, 115, 50, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[5296, 140, 62, 1, 47, "GuideTitle",
 CellID->942062912],
Cell[5361, 143, 142, 4, 48, "GuideAbstract",
 CellID->2001916300]
}, Open  ]],
Cell[CellGroupData[{
Cell[5540, 152, 257, 11, 30, "GuideReferenceSection"],
Cell[5800, 165, 31, 0, 14, "SectionHeaderSpacer"],
Cell[CellGroupData[{
Cell[5856, 169, 87, 1, 30, "GuideFunctionsSubsection",
 CellID->351933073],
Cell[5946, 172, 575, 10, 100, "GuideText",
 CellID->348045444],
Cell[6524, 184, 269, 9, 20, "GuideText",
 CellID->203374175],
Cell[6796, 195, 270, 9, 20, "GuideText",
 CellID->1463276848],
Cell[7069, 206, 300, 9, 20, "GuideText",
 CellID->56750302],
Cell[7372, 217, 353, 11, 22, "GuideText",
 CellID->769448525],
Cell[7728, 230, 58, 1, 21, "GuideDelimiterSubsection",
 CellID->311258892]
}, Open  ]],
Cell[CellGroupData[{
Cell[7823, 236, 75, 1, 30, "GuideFunctionsSubsection",
 CellID->155582371],
Cell[7901, 239, 448, 8, 86, "GuideText",
 CellID->209193518]
}, Open  ]],
Cell[8364, 250, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8432, 255, 281, 12, 30, "GuideMoreAboutSection",
 CellID->23220180],
Cell[8716, 269, 31, 0, 14, "SectionHeaderSpacer"],
Cell[8750, 271, 205, 6, 20, "GuideMoreAbout",
 CellID->1567025153]
}, Open  ]],
Cell[8970, 280, 23, 0, 41, "FooterCell"]
}
]
*)

