(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10761,        310]
NotebookOptionsPosition[      6320,        200]
NotebookOutlinePosition[      9894,        282]
CellTagsIndexPosition[      9851,        279]
WindowTitle->Input
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA GUIDE", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Input Aliases\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/guide/InputAliases"], "\<\"Palette Input\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/guide/PaletteInput"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideMoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/guide/Input\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/guide/Input"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/guide/\
Input.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$5985], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/guide/Input", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Input", "GuideTitle",
 CellID->942062912],

Cell["\<\
There are several ways to enter Quantum Algebra expressions into a notebook.\
\>", "GuideAbstract",
 CellID->2001916300],

Cell["\<\
One way is to use input aliases to place an input template into the notebook. \
After this you must fill the placeholders in those templates. Quantum Algebra \
comes with a series of additional input aliases.\
\>", "GuideAbstract",
 CellID->58765407],

Cell["\<\
Another way is to choose shapes from the various palettes in the front end. \
Quantum Algebra has no own palettes, so you must use those from Mathematica.\
\>", "GuideAbstract",
 CellID->2470810],

Cell["\<\
To fill the placeholders the use of additional input templates or palette \
buttons or alias keystrokes may be required.\
\>", "GuideAbstract",
 CellID->721163492],

Cell["\<\
Finally you may enter expressions in their Full Form notation or a mix of \
notations.\
\>", "GuideAbstract",
 CellID->400829683]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Reference"
}], "GuideReferenceSection",
 WholeCellGroupOpener->True],

Cell["", "SectionHeaderSpacer"],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Related Guides"
}], "GuideMoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[{
 TemplateBox[{Cell[
    TextData["Input Aliases"]],"paclet:QuantumAlgebra/guide/InputAliases"},
  "RefLink",
  BaseStyle->"GuideMoreAbout"], "\n", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"-", " ", "An"}], " ", "overview", " ", "about", " ", "the", " ", 
   "input", " ", "aliases", " ", "provided", " ", "by", " ", "Quantum", " ", 
   "Algebra"}]}]}], "GuideMoreAbout",
 CellID->1567025153],

Cell[BoxData[{
 TemplateBox[{Cell[
    TextData["Palette Input"]],"paclet:QuantumAlgebra/guide/PaletteInput"},
  "RefLink",
  BaseStyle->"GuideMoreAbout"], "\n", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"-", " ", "An"}], " ", "overview", " ", "about", " ", "input", " ",
    "enabled", " ", "by", " ", "use", " ", "of", " ", "the", " ", 
   "Mathematica", " ", "palettes"}]}]}], "GuideMoreAbout",
 CellID->252299663]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Input",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 27.5464107}", 
    "history" -> {"2.1", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Guide", "language" -> "en", "paclet" -> "QuantumAlgebra",
     "status" -> "None", "summary" -> 
    "There are several ways to enter Quantum Algebra expressions into a \
notebook.", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$5910, "title" -> 
    "Input", "titlemodifier" -> "", "windowtitle" -> "Input", "type" -> 
    "Guide", "uri" -> "QuantumAlgebra/guide/Input"}, "SearchTextTranslated" -> 
  ""},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}]}, Visible -> False, FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[577, 21, 3171, 76, 50, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3773, 101, 47, 1, 47, "GuideTitle",
 CellID->942062912],
Cell[3823, 104, 130, 3, 48, "GuideAbstract",
 CellID->2001916300],
Cell[3956, 109, 260, 5, 68, "GuideAbstract",
 CellID->58765407],
Cell[4219, 116, 205, 4, 68, "GuideAbstract",
 CellID->2470810],
Cell[4427, 122, 173, 4, 68, "GuideAbstract",
 CellID->721163492],
Cell[4603, 128, 139, 4, 48, "GuideAbstract",
 CellID->400829683]
}, Open  ]],
Cell[CellGroupData[{
Cell[4779, 137, 257, 11, 30, "GuideReferenceSection"],
Cell[5039, 150, 31, 0, 14, "SectionHeaderSpacer"],
Cell[5073, 152, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5141, 157, 281, 12, 30, "GuideMoreAboutSection",
 CellID->23220180],
Cell[5425, 171, 31, 0, 14, "SectionHeaderSpacer"],
Cell[5459, 173, 403, 10, 35, "GuideMoreAbout",
 CellID->1567025153],
Cell[5865, 185, 413, 10, 35, "GuideMoreAbout",
 CellID->252299663]
}, Open  ]],
Cell[6293, 198, 23, 0, 41, "FooterCell"]
}
]
*)

