(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20245,        632]
NotebookOptionsPosition[     14347,        477]
NotebookOutlinePosition[     18726,        576]
CellTagsIndexPosition[     18641,        571]
WindowTitle->BraKet
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Bra\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Bra"], "\<\"Ket\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Ket"], "\<\"Operator\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/Operator"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/BraKet\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/BraKet"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
BraKet.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$9048], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/BraKet", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["BraKet", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"BraKet", "[", 
       RowBox[{
        RowBox[{"{", "A__", "}"}], ",", 
        RowBox[{"{", "B__", "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]is the simple form of a BraKet object where the \
sequences A and B label the BraKet. Additional forms allow the usage of \
indices. Whereas the indices of Kets are on their right-hand side and the \
indices of Bras are on their left-hand side, BraKets can have their indices \
placed on both sides. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"BraKet", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"A__", ",", 
          RowBox[{"{", 
           StyleBox["x__", "TI"], "}"}], ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", "B__", "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]has placed subscripts (x) on the left-hand side. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"BraKet", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"A__", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           StyleBox["y__", "TI"], "}"}]}], "}"}], ",", 
        RowBox[{"{", "B__", "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]has superscripts (y) on the left. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"BraKet", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"A__", ",", 
          RowBox[{"{", 
           StyleBox["x__", "TI"], "}"}], ",", 
          RowBox[{"{", 
           StyleBox["y__", "TI"], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"B__", ",", 
          RowBox[{"{", 
           StyleBox["u__", "TI"], "}"}], ",", 
          RowBox[{"{", 
           StyleBox["v__", "TI"], "}"}]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]has all kinds of indices. More combinations are \
possible. "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->181989541],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
ALIASES: \[LineSeparator][ESC] braket [ESC]     : braket \
\[LineSeparator][ESC] braketd [ESC]    : braket with right-handed subscript \
\[LineSeparator][ESC] ubraket [ESC]    : braket with left-handed superscript \
\[LineSeparator][ESC] dubraketdu [ESC] : braket with both scripts on both \
sides. \[LineSeparator]More combinations are possible using u(up) and \
d(down). \[LineSeparator]\[LineSeparator]BraKet is also used as a tag for \
TagBoxes that guide the interpretation of the internal structure of braket \
notation.\
\>", "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->23032144],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->194890744],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Needs", "[", "\"\<QuantumAlgebra`\>\"", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->428642466],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellID->444629057],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellID->224266972],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellID->195925690],

Cell[BoxData["\<\"For proper styling You should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellID->874749501]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Input", " ", "in", " ", "FullForm"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"BraKet", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"{", "i", "}"}], ",", 
      RowBox[{"{", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", 
      RowBox[{"{", "j", "}"}], ",", 
      RowBox[{"{", "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->33993729],

Cell[BoxData[
 TagBox[
  RowBox[{
   SubscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["i",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   SubscriptBox[
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      RowBox[{
       TagBox["m",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
       TagBox["n",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"]}],
      BoxBaselineShift->0], "\[RightAngleBracket]"}], 
    TagBox[
     AdjustmentBox[
      TagBox["j",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"RIndex"]]}],
  BraKet,
  BaseStyle->"BraKetWrapper"]], "Output",
 ImageSize->{59, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->203042339]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Input", " ", "with", " ", "Input", " ", "Alias", " ", "ESC", " ", 
    "dbraketd", " ", "ESC"}], " ", "*)"}], "\[IndentingNewLine]", 
  TagBox[
   RowBox[{
    SubscriptBox["\[InvisiblePrefixScriptBase]", 
     TagBox[
      AdjustmentBox[
       TagBox["i",
        QuantumAlgebra`QuantumNotation`BraArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0],
      QuantumAlgebra`QuantumNotation`UDScript,
      BaseStyle->"LIndex"]], 
    SubscriptBox[
     RowBox[{"\[LeftAngleBracket]", 
      AdjustmentBox[
       RowBox[{
        TagBox["u",
         QuantumAlgebra`QuantumNotation`BraKetArgs,
         BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
        TagBox["v",
         QuantumAlgebra`QuantumNotation`BraKetArgs,
         BaseStyle->"BraKetArg"]}],
       BoxBaselineShift->0], "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox["j",
        QuantumAlgebra`QuantumNotation`BraArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0],
      QuantumAlgebra`QuantumNotation`UDScript,
      BaseStyle->"RIndex"]]}],
   BraKet,
   BaseStyle->"BraKetWrapper"]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->531124749],

Cell[BoxData[
 TagBox[
  RowBox[{
   SubscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["i",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   SubscriptBox[
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      RowBox[{
       TagBox["u",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
       TagBox["v",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"]}],
      BoxBaselineShift->0], "\[RightAngleBracket]"}], 
    TagBox[
     AdjustmentBox[
      TagBox["j",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"RIndex"]]}],
  BraKet,
  BaseStyle->"BraKetWrapper"]], "Output",
 ImageSize->{59, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->179914207]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellLabel->"In[4]:=",
 CellID->18821223]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Bra"]],"paclet:QuantumAlgebra/ref/Bra"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Ket"]],"paclet:QuantumAlgebra/ref/Ket"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Operator"]],"paclet:QuantumAlgebra/ref/Operator"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"BraKet",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 38.2138918}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"Operator Bra Ket BraKet Dirac"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "BraKet[{A__}, {B__}] is the simple form of a BraKet object where the \
sequences A and B label the BraKet. Additional forms allow the usage of \
indices. Whereas the indices of Kets are on their right-hand side and the \
indices of Bras are on their left-hand side, BraKets can have their indices \
placed on both sides. BraKet[{A__, {x__}, {}}, {B__}] has placed subscripts \
(x) on the left-hand side. BraKet[{A__, {}, {y__}}, {B__}] has superscripts \
(y) on the left. BraKet[{A__, {x__}, {y__}}, {B__, {u__}, {v__}}] has all \
kinds of indices. More combinations are possible. ", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "BraKet", "titlemodifier" -> "", 
    "windowtitle" -> "BraKet", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/BraKet"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7638, 223, 386, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->23032144]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18499, 564}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[578, 21, 3207, 77, 50, "AnchorBarGrid",
 CellID->1],
Cell[3788, 100, 283, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4096, 115, 2121, 60, 284, "Usage"],
Cell[CellGroupData[{
Cell[6242, 179, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->181989541],
Cell[6983, 205, 31, 0, 70, "SectionHeaderSpacer"],
Cell[7017, 207, 572, 10, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7638, 223, 386, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->23032144],
Cell[CellGroupData[{
Cell[8049, 242, 195, 6, 25, "ExampleSection",
 CellID->194890744],
Cell[CellGroupData[{
Cell[8269, 252, 252, 7, 43, "Input",
 CellID->428642466],
Cell[CellGroupData[{
Cell[8546, 263, 99, 1, 22, "Print",
 CellID->444629057],
Cell[8648, 266, 109, 2, 22, "Print",
 CellID->224266972],
Cell[8760, 270, 114, 2, 22, "Print",
 CellID->195925690],
Cell[8877, 274, 116, 2, 22, "Print",
 CellID->874749501]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9042, 282, 470, 16, 43, "Input",
 CellID->33993729],
Cell[9515, 300, 1105, 37, 39, "Output",
 CellID->203042339]
}, Open  ]],
Cell[CellGroupData[{
Cell[10657, 342, 1233, 39, 52, "Input",
 CellID->531124749],
Cell[11893, 383, 1105, 37, 39, "Output",
 CellID->179914207]
}, Open  ]],
Cell[13013, 423, 87, 2, 70, "Input",
 CellID->18821223]
}, Open  ]],
Cell[13115, 428, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13183, 433, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[13456, 447, 849, 25, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[14320, 475, 23, 0, 70, "FooterCell"]
}
]
*)

