(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     19956,        627]
NotebookOptionsPosition[     14182,        469]
NotebookOutlinePosition[     18268,        565]
CellTagsIndexPosition[     18183,        560]
WindowTitle->DefineCommutatorRule
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DefineNameOrderingRule\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/DefineNameOrderingRule"], \
"\<\"QAReplace\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReplace"], "\<\"QAReplaceRepeated\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReplaceRepeated"], "\<\"QASelectDefault\"\
\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QASelectDefault"], \
"\<\"QAAddReplacementRules\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAAddReplacementRules"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/DefineCommutatorRule\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/DefineCommutatorRule"]}, Visible -> 
            False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
DefineCommutatorRule.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$13225], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/DefineCommutatorRule", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["DefineCommutatorRule", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DefineCommutatorRule", "[", 
       RowBox[{
        StyleBox["anti", "TI"], ",", " ", 
        StyleBox["continuous", "TI"], ",", " ", 
        StyleBox["normal", "TI"], ",", " ", 
        StyleBox["dim", "TI"]}], 
       StyleBox["]", "TI"]}]], "InlineFormula"],
     "\[LineSeparator]uses a Commutator / Anti-Commutator relation to sort \
operators."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->103718617],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
This function returns a rule establishing an ordering between pairs of \
Hermitian/Non-Hermitian operators. It uses commutator/anti-commutator \
relations for this purpose.\
\>", "Notes",
 CellID->1067943069],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->319087746],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"anti\"\>", "Notes"], 
     StyleBox["\<\"Whether to use a anti-commutator/commutator\"\>", "Notes"]},
    {
     StyleBox["\<\"continuous\"\>", "Notes"], 
     StyleBox["\<\"Whether to handle the continuous/discrete case\"\>", 
      "Notes"]},
    {
     StyleBox["\<\"normal\"\>", "Notes"], 
     StyleBox["\<\"Whether to return normal ordered or reverse ordered \
operators\"\>", "Notes"]},
    {
     StyleBox["\<\"dim\"\>", "Notes"], 
     StyleBox["\<\"The dimension, defaults to 3\"\>", "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output"]], "Notes",
 CellID->47800268]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->283204099],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->136852372],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91566771],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[11]:=",
 CellID->33826796],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[11]:=",
 CellID->308567175],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[11]:=",
 CellID->469761563],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[11]:=",
 CellID->203530404]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Selects", " ", "the", " ", "default", " ", "set"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"QASelectDefault", "[", "\"\<KleinGordon\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->25991509],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Adds", " ", "2", " ", "replacement", " ", "rules", " ", "under", " ", 
    "the", " ", "name", " ", "\"\<commutator\>\""}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QAAddReplacementRules", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"DefineCommutatorRule", "[", 
        RowBox[{"False", ",", "True", ",", "True"}], "]"}], ",", 
       RowBox[{"DefineNameOrderingRule", "[", "False", "]"}]}], "}"}], ",", 
     "\"\<commutator\>\""}], "]"}], ";"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->104380238],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defines", " ", "a", " ", "pair", " ", "of", " ", "multiplied", " ", 
    "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"pair", "=", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["a", "^"], 
     RowBox[{
      SubscriptBox["k", "1"], ",", 
      SubscriptBox["k", "2"], ",", 
      SubscriptBox["k", "3"]}]], "\[CenterDot]", 
    SubsuperscriptBox[
     OverscriptBox["a", "^"], 
     RowBox[{
      SubscriptBox["l", "1"], ",", 
      SubscriptBox["l", "2"], ",", 
      SubscriptBox["l", "3"]}], "\[Dagger]"]}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->412025834],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["a", "^"], 
   RowBox[{
    SubscriptBox["k", "1"], ",", 
    SubscriptBox["k", "2"], ",", 
    SubscriptBox["k", "3"]}]], "\[CenterDot]", 
  SubsuperscriptBox[
   OverscriptBox["a", "^"], 
   RowBox[{
    SubscriptBox["l", "1"], ",", 
    SubscriptBox["l", "2"], ",", 
    SubscriptBox["l", "3"]}], "\[Dagger]"]}]], "Output",
 ImageSize->{117, 21},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->330398700]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Applies", " ", "the", " ", "rules", " ", "defined", " ", "before"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"pair", "//", 
   RowBox[{"QAReplace", "[", "\"\<commutator\>\"", "]"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->92929731],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubsuperscriptBox[
    OverscriptBox["a", "^"], 
    RowBox[{
     SubscriptBox["l", "1"], ",", 
     SubscriptBox["l", "2"], ",", 
     SubscriptBox["l", "3"]}], "\[Dagger]"], "\[CenterDot]", 
   SubscriptBox[
    OverscriptBox["a", "^"], 
    RowBox[{
     SubscriptBox["k", "1"], ",", 
     SubscriptBox["k", "2"], ",", 
     SubscriptBox["k", "3"]}]]}], "+", 
  RowBox[{
   RowBox[{"DiracDelta", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SubscriptBox["k", "1"]}], "+", 
      SubscriptBox["l", "1"]}], ",", 
     RowBox[{
      RowBox[{"-", 
       SubscriptBox["k", "2"]}], "+", 
      SubscriptBox["l", "2"]}], ",", 
     RowBox[{
      RowBox[{"-", 
       SubscriptBox["k", "3"]}], "+", 
      SubscriptBox["l", "3"]}]}], "]"}], " ", 
   OverscriptBox["1", "^"]}]}]], "Output",
 ImageSize->{387, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->46289819]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DefineNameOrderingRule"]],
    "paclet:QuantumAlgebra/ref/DefineNameOrderingRule"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReplace"]],"paclet:QuantumAlgebra/ref/QAReplace"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReplaceRepeated"]],
    "paclet:QuantumAlgebra/ref/QAReplaceRepeated"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QASelectDefault"]],"paclet:QuantumAlgebra/ref/QASelectDefault"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAAddReplacementRules"]],
    "paclet:QuantumAlgebra/ref/QAAddReplacementRules"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DefineCommutatorRule",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 52.8477682}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", 
    "keywords" -> {
     "DefineCommutatorRule DefineNameOrderingRule QAReplace QAReplaceRepeated \
QASelectDefault QAAddReplacementRules"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "DefineCommutatorRule[anti, continuous, normal, dim] uses a Commutator / \
Anti-Commutator relation to sort operators.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "DefineCommutatorRule", "titlemodifier" -> 
    "", "windowtitle" -> "DefineCommutatorRule", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/DefineCommutatorRule"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7229, 212, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->283204099]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18040, 553}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 3595, 85, 50, "AnchorBarGrid",
 CellID->1],
Cell[4190, 108, 297, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4512, 123, 596, 17, 80, "Usage"],
Cell[CellGroupData[{
Cell[5133, 144, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->103718617],
Cell[5874, 170, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5908, 172, 218, 5, 70, "Notes",
 CellID->1067943069],
Cell[6129, 179, 81, 1, 70, "Notes",
 CellID->319087746],
Cell[6213, 182, 967, 24, 70, "Notes",
 CellID->47800268]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7229, 212, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->283204099],
Cell[CellGroupData[{
Cell[7641, 231, 195, 6, 25, "ExampleSection",
 CellID->136852372],
Cell[CellGroupData[{
Cell[7861, 241, 238, 7, 43, "Input",
 CellID->91566771],
Cell[CellGroupData[{
Cell[8124, 252, 143, 2, 22, "Print",
 CellID->33826796],
Cell[8270, 256, 154, 3, 22, "Print",
 CellID->308567175],
Cell[8427, 261, 159, 3, 22, "Print",
 CellID->469761563],
Cell[8589, 266, 161, 3, 22, "Print",
 CellID->203530404]
}, Open  ]]
}, Open  ]],
Cell[8777, 273, 267, 7, 43, "Input",
 CellID->25991509],
Cell[9047, 282, 611, 17, 59, "Input",
 CellID->104380238],
Cell[CellGroupData[{
Cell[9683, 303, 652, 21, 48, "Input",
 CellID->412025834],
Cell[10338, 326, 514, 18, 42, "Output",
 CellID->330398700]
}, Open  ]],
Cell[CellGroupData[{
Cell[10889, 349, 310, 9, 43, "Input",
 CellID->92929731],
Cell[11202, 360, 971, 35, 44, "Output",
 CellID->46289819]
}, Open  ]]
}, Open  ]],
Cell[12200, 399, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12268, 404, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[12541, 418, 1599, 46, 70, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[14155, 467, 23, 0, 70, "FooterCell"]
}
]
*)

