(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17896,        578]
NotebookOptionsPosition[     12000,        412]
NotebookOutlinePosition[     15971,        506]
CellTagsIndexPosition[     15886,        501]
WindowTitle->QAAddAssumptions
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAResetAssumptions\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAResetAssumptions"], "\<\"QAGetAssumptions\
\"\>":>Documentation`HelpLookup["paclet:QuantumAlgebra/ref/QAGetAssumptions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAAddAssumptions\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAAddAssumptions"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAAddAssumptions.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$21636], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAAddAssumptions", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAAddAssumptions", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{"QAAddAssumptions", "[", 
        RowBox[{
         StyleBox["ass", "TI"], ",", " ", 
         StyleBox["set", "TI"]}], "]"}], " "}]], "InlineFormula"],
     "\[LineSeparator]adds a list of assumptions to the given set of \
Assumptions."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->85898312],

Cell["", "SectionHeaderSpacer"],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->1067943069],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"ass\"\>", "Notes"], 
     StyleBox[
      RowBox[{
      "The", " ", "ass", " ", "parameter", " ", "must", " ", "be", " ", "a", 
       " ", "list", " ", "of", " ", "assumptions"}], "Notes"]},
    {
     StyleBox["\<\"set\"\>", "Notes"], 
     StyleBox[
      RowBox[{"The", " ", "set", " ", "name", " ", "or", " ", 
       RowBox[{"(", 
        RowBox[{
        "Null", " ", "or", " ", "left", " ", "empty", " ", "for", " ", "the", 
         " ", "default", " ", "set"}], ")"}]}], "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->649193982],

Cell["\<\
The assumptions can be useful to simplify expressions. For instance is the \
assumption for being Real useful to build the Conjugate.\
\>", "Notes",
 CellID->716197103]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->215191454],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->370578922],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91566771],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[45]:=",
 CellID->268907597],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[45]:=",
 CellID->44448898],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[45]:=",
 CellID->556606101],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[45]:=",
 CellID->326102286]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Selects", " ", "the", " ", "default", " ", "set"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"QASelectDefault", "[", "\"\<Dirac\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->25991509],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defines", " ", "an", " ", "expression", " ", "containing", " ", "\[Mu]", 
    " ", "being", " ", "complex"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex", "=", 
   RowBox[{"3", "  ", "\[Mu]"}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->50779773],

Cell[BoxData[
 RowBox[{"3", " ", "\[Mu]"}]], "Output",
 ImageSize->{21, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->72285802]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Calculate", " ", "the", " ", "Conjugate"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"conjugate", "=", 
   RowBox[{"Conjugate", "[", "ex", "]"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->265168351],

Cell[BoxData[
 RowBox[{"3", " ", 
  SuperscriptBox["\[Mu]", "*"]}]], "Output",
 ImageSize->{27, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->255535378]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Add", " ", "an", " ", "assumption", " ", "that", " ", "\[Mu]", " ", "is", 
    " ", "Real"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAAddAssumptions", "[", 
   RowBox[{"{", 
    RowBox[{"\[Mu]", "\[Element]", "Reals"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->489684336],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{"\<\"Dirac\"\>", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"\[Mu]", "\[Element]", "Reals"}], "}"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{151, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->71160639]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Simplify", " ", "under", " ", "this", " ", "assumption"}], " ", 
    "\[Rule]", " ", 
    RowBox[{"no", " ", "conjugation", " ", "is", " ", "left"}]}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{"conjugate2", "=", 
   RowBox[{
    RowBox[{"Conjugate", "[", "ex", "]"}], "//", 
    RowBox[{"QASimplify", "[", "]"}]}]}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->23254574],

Cell[BoxData[
 RowBox[{"3", " ", "\[Mu]"}]], "Output",
 ImageSize->{21, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->569926779]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAResetAssumptions"]],
    "paclet:QuantumAlgebra/ref/QAResetAssumptions"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAGetAssumptions"]],
    "paclet:QuantumAlgebra/ref/QAGetAssumptions"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAAddAssumptions",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 21.9429820}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`Agreements`", 
    "keywords" -> {"QAResetAssumptions QAAddAssumptions QAGetAssumptions"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAAddAssumptions[ass, set] adds a list of assumptions to the given set \
of Assumptions.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QAAddAssumptions", "titlemodifier" -> "", "windowtitle" -> 
    "QAAddAssumptions", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QAAddAssumptions"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6732, 202, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->215191454]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15743, 494}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[588, 21, 3208, 76, 50, "AnchorBarGrid",
 CellID->1],
Cell[3799, 99, 293, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4117, 114, 495, 15, 80, "Usage"],
Cell[CellGroupData[{
Cell[4637, 133, 737, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->85898312],
Cell[5377, 159, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5411, 161, 82, 1, 70, "Notes",
 CellID->1067943069],
Cell[5496, 164, 1006, 26, 70, "Notes",
 CellID->649193982],
Cell[6505, 192, 178, 4, 70, "Notes",
 CellID->716197103]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6732, 202, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->215191454],
Cell[CellGroupData[{
Cell[7144, 221, 195, 6, 25, "ExampleSection",
 CellID->370578922],
Cell[CellGroupData[{
Cell[7364, 231, 238, 7, 43, "Input",
 CellID->91566771],
Cell[CellGroupData[{
Cell[7627, 242, 144, 2, 22, "Print",
 CellID->268907597],
Cell[7774, 246, 153, 3, 22, "Print",
 CellID->44448898],
Cell[7930, 251, 159, 3, 22, "Print",
 CellID->556606101],
Cell[8092, 256, 161, 3, 22, "Print",
 CellID->326102286]
}, Open  ]]
}, Open  ]],
Cell[8280, 263, 261, 7, 43, "Input",
 CellID->25991509],
Cell[CellGroupData[{
Cell[8566, 274, 319, 9, 43, "Input",
 CellID->50779773],
Cell[8888, 285, 183, 6, 35, "Output",
 CellID->72285802]
}, Open  ]],
Cell[CellGroupData[{
Cell[9108, 296, 269, 8, 43, "Input",
 CellID->265168351],
Cell[9380, 306, 208, 7, 35, "Output",
 CellID->255535378]
}, Open  ]],
Cell[CellGroupData[{
Cell[9625, 318, 360, 10, 43, "Input",
 CellID->489684336],
Cell[9988, 330, 325, 10, 35, "Output",
 CellID->71160639]
}, Open  ]],
Cell[CellGroupData[{
Cell[10350, 345, 450, 13, 43, "Input",
 CellID->23254574],
Cell[10803, 360, 184, 6, 35, "Output",
 CellID->569926779]
}, Open  ]]
}, Open  ]],
Cell[11014, 370, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11082, 375, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11355, 389, 603, 18, 70, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[11973, 410, 23, 0, 70, "FooterCell"]
}
]
*)

