(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16916,        535]
NotebookOptionsPosition[     11746,        394]
NotebookOutlinePosition[     15638,        487]
CellTagsIndexPosition[     15553,        482]
WindowTitle->QAClear
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QASet\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QASet"], "\<\"Commutator\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Commutator"], "\<\"Ket\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/Ket"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAClear\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAClear"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAClear.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$23715], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAClear", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAClear", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAClear", "[", " ", 
       RowBox[{
        StyleBox["lhs", "TI"], " ", "=."}], " ", "]"}]], "InlineFormula"],
     "\[LineSeparator]removes all definitions made by ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["QASet"]],"paclet:QuantumAlgebra/ref/QASet"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     " associated with the definition of lhs. See ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["QASet"]],"paclet:QuantumAlgebra/ref/QASet"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     ". "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->286357984],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->762497179],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->158584138],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[48]:=",
 CellID->860005776],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[48]:=",
 CellID->64219092],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[48]:=",
 CellID->147949717],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[48]:=",
 CellID->8362696]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Define", " ", "a", " ", "relation", " ", "with", " ", "QASet"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QASet", "[", 
   RowBox[{
    RowBox[{
     OverscriptBox["H", "^"], "\[CenterDot]", 
     TagBox[
      RowBox[{
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox["\[Psi]",
         QuantumAlgebra`QuantumNotation`KetArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], "\[RightAngleBracket]"}],
      QuantumAlgebra`Ket,
      BaseStyle->"KetWrapper"]}], "=", 
    RowBox[{"En", " ", 
     TagBox[
      RowBox[{
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox["\[Psi]",
         QuantumAlgebra`QuantumNotation`KetArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], "\[RightAngleBracket]"}],
      QuantumAlgebra`Ket,
      BaseStyle->"KetWrapper"]}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->4392825],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Try", " ", "an", " ", "expression", " ", "with", " ", "right", " ", 
    "hand", " ", "side"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   OverscriptBox["H", "^"], "\[CenterDot]", 
   TagBox[
    RowBox[{
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{-0.4, 0.}, {0, 0}}], 
     AdjustmentBox[
      TagBox["\[Psi]",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], "\[RightAngleBracket]"}],
    QuantumAlgebra`Ket,
    BaseStyle->"KetWrapper"]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->552250],

Cell[BoxData[
 RowBox[{"En", " ", 
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["\[Psi]",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"]}]], "Output",
 ImageSize->{46, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->99786640]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Delete", " ", "relation", " ", "and", " ", "try", " ", "again"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAClear", "[", 
   RowBox[{
    RowBox[{
     OverscriptBox["H", "^"], "\[CenterDot]", 
     TagBox[
      RowBox[{
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox["\[Psi]",
         QuantumAlgebra`QuantumNotation`KetArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], "\[RightAngleBracket]"}],
      QuantumAlgebra`Ket,
      BaseStyle->"KetWrapper"]}], "=."}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->102362766],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  OverscriptBox["H", "^"], "\[CenterDot]", 
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["\[Psi]",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->55344160],

Cell[BoxData[
 RowBox[{
  OverscriptBox["H", "^"], "\[CenterDot]", 
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["\[Psi]",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"]}]], "Output",
 ImageSize->{47, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->93407129]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QASet"]],"paclet:QuantumAlgebra/ref/QASet"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Ket"]],"paclet:QuantumAlgebra/ref/Ket"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAClear",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 30.1071545}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"QAClear QASet"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAClear[lhs =. ] removes all definitions made by QASet associated with \
the definition of lhs. See QASet. ", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "QAClear", "titlemodifier" -> "", "windowtitle" -> "QAClear", 
    "type" -> "Symbol", "uri" -> "QuantumAlgebra/ref/QAClear"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4954, 141, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->286357984]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15410, 475}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[579, 21, 3220, 77, 50, "AnchorBarGrid",
 CellID->1],
Cell[3802, 100, 284, 11, 44, "ObjectNameGrid"],
Cell[4089, 113, 840, 24, 83, "Usage"],
Cell[CellGroupData[{
Cell[4954, 141, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->286357984],
Cell[CellGroupData[{
Cell[5366, 160, 195, 6, 25, "ExampleSection",
 CellID->762497179],
Cell[CellGroupData[{
Cell[5586, 170, 239, 7, 43, "Input",
 CellID->158584138],
Cell[CellGroupData[{
Cell[5850, 181, 144, 2, 22, "Print",
 CellID->860005776],
Cell[5997, 185, 153, 3, 22, "Print",
 CellID->64219092],
Cell[6153, 190, 159, 3, 22, "Print",
 CellID->147949717],
Cell[6315, 195, 159, 3, 22, "Print",
 CellID->8362696]
}, Open  ]]
}, Open  ]],
Cell[6501, 202, 1078, 33, 49, "Input",
 CellID->4392825],
Cell[CellGroupData[{
Cell[7604, 239, 643, 20, 47, "Input",
 CellID->552250],
Cell[8250, 261, 504, 17, 37, "Output",
 CellID->99786640]
}, Open  ]],
Cell[8769, 281, 696, 21, 49, "Input",
 CellID->102362766],
Cell[CellGroupData[{
Cell[9490, 306, 449, 15, 32, "Input",
 CellID->55344160],
Cell[9942, 323, 537, 18, 41, "Output",
 CellID->93407129]
}, Open  ]]
}, Open  ]],
Cell[10506, 345, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10574, 350, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[10847, 364, 857, 25, 58, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[11719, 392, 23, 0, 70, "FooterCell"]
}
]
*)

