(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15256,        472]
NotebookOptionsPosition[     10106,        334]
NotebookOutlinePosition[     14092,        428]
CellTagsIndexPosition[     14007,        423]
WindowTitle->QAExpandAll
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAPowerExpand\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAPowerExpand"], "\<\"QAProductExpand\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAProductExpand"], \
"\<\"QACommutatorExpand\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QACommutatorExpand"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAExpandAll\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAExpandAll"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAExpandAll.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$25834], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAExpandAll", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAExpandAll", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAExpandAll", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]performs the following commands in expr: ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["QAPowerExpand"]],"paclet:QuantumAlgebra/ref/QAPowerExpand"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["QAProductExpand"]],
        "paclet:QuantumAlgebra/ref/QAProductExpand"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     ", and ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["QACommutatorExpand"]],
        "paclet:QuantumAlgebra/ref/QACommutatorExpand"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     " in that order. "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->99518579],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->329926199],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->211598779],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[15]:=",
 CellID->103427740],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[15]:=",
 CellID->55225805],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[15]:=",
 CellID->78266083],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[15]:=",
 CellID->513091473]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Define", " ", "a", " ", "square", " ", "of", " ", "a", " ", 
    "commutator"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex1", "=", 
   RowBox[{
    SubscriptBox[
     RowBox[{"[", 
      RowBox[{
       OverscriptBox["A", "^"], ",", 
       OverscriptBox["B", "^"]}], "]"}], "-"], "^", "2"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->546906685],

Cell[BoxData[
 SubsuperscriptBox[
  RowBox[{"[", 
   RowBox[{
    OverscriptBox["A", "^"], ",", 
    OverscriptBox["B", "^"]}], "]"}], "-", "2"]], "Output",
 ImageSize->{49, 21},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->402353241]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "QAExpandAll", " ", "resolves", " ", "the", " ", "square", " ", "and", " ",
     "the", " ", "commutator"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex1", "//", "QAExpandAll"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->203176085],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["B", "^"]}], "-", 
  RowBox[{
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["A", "^"]}], "-", 
  RowBox[{
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["B", "^"]}], "+", 
  RowBox[{
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["A", "^"]}]}]], "Output",
 ImageSize->{287, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->683957189]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAPowerExpand"]],"paclet:QuantumAlgebra/ref/QAPowerExpand"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAProductExpand"]],"paclet:QuantumAlgebra/ref/QAProductExpand"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QACommutatorExpand"]],
    "paclet:QuantumAlgebra/ref/QACommutatorExpand"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->176918447]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAExpandAll",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 38.3940001}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {
     "QAExpandAll QAPowerExpand QAProductExpand QACommutatorExpand"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAExpandAll[expr] performs the following commands in expr: \
QAPowerExpand, QAProductExpand, and QACommutatorExpand in that order. ", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "QAExpandAll", 
    "titlemodifier" -> "", "windowtitle" -> "QAExpandAll", "type" -> "Symbol",
     "uri" -> "QuantumAlgebra/ref/QAExpandAll"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5270, 150, 386, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->99518579]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13865, 416}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[583, 21, 3304, 79, 50, "AnchorBarGrid",
 CellID->1],
Cell[3890, 102, 288, 11, 44, "ObjectNameGrid"],
Cell[4181, 115, 1064, 31, 97, "Usage"],
Cell[CellGroupData[{
Cell[5270, 150, 386, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->99518579],
Cell[CellGroupData[{
Cell[5681, 169, 195, 6, 25, "ExampleSection",
 CellID->329926199],
Cell[CellGroupData[{
Cell[5901, 179, 239, 7, 43, "Input",
 CellID->211598779],
Cell[CellGroupData[{
Cell[6165, 190, 144, 2, 22, "Print",
 CellID->103427740],
Cell[6312, 194, 153, 3, 22, "Print",
 CellID->55225805],
Cell[6468, 199, 158, 3, 22, "Print",
 CellID->78266083],
Cell[6629, 204, 161, 3, 22, "Print",
 CellID->513091473]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6839, 213, 420, 14, 49, "Input",
 CellID->546906685],
Cell[7262, 229, 286, 10, 42, "Output",
 CellID->402353241]
}, Open  ]],
Cell[CellGroupData[{
Cell[7585, 244, 301, 8, 43, "Input",
 CellID->203176085],
Cell[7889, 254, 889, 26, 39, "Output",
 CellID->683957189]
}, Open  ]]
}, Open  ]],
Cell[8805, 284, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8873, 289, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[9146, 303, 918, 26, 58, "SeeAlso",
 CellID->176918447]
}, Open  ]],
Cell[10079, 332, 23, 0, 41, "FooterCell"]
}
]
*)

