(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14941,        476]
NotebookOptionsPosition[      9719,        333]
NotebookOutlinePosition[     13628,        426]
CellTagsIndexPosition[     13543,        421]
WindowTitle->QAPowerExpand
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Operator\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Operator"], "\<\"QAPowerContract\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/QAPowerContract"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAPowerExpand\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAPowerExpand"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAPowerExpand.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$33097], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAPowerExpand", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAPowerExpand", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAPowerExpand", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]expands all powers in expr as non-commutative products."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->34501765],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->180032573],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->144071775],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[18]:=",
 CellID->275869943],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[18]:=",
 CellID->257456957],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[18]:=",
 CellID->319816467],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[18]:=",
 CellID->940176453]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Sum", " ", "of", " ", "operators"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"sum", "=", 
   RowBox[{
    OverscriptBox["A", "^"], "+", 
    OverscriptBox["B", "^"]}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->130503262],

Cell[BoxData[
 RowBox[{
  OverscriptBox["A", "^"], "+", 
  OverscriptBox["B", "^"]}]], "Output",
 ImageSize->{31, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->323852225]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Define", " ", "power", " ", "of", " ", "it"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"power", "=", 
   RowBox[{"sum", "^", "3"}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->659622813],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"(", 
   RowBox[{
    OverscriptBox["A", "^"], "+", 
    OverscriptBox["B", "^"]}], ")"}], "3"]], "Output",
 ImageSize->{51, 22},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1029824]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Power", " ", "expand", " ", "and", " ", "subsequently", " ", "power", 
     " ", "contract"}], " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"it", "'"}], "s", " ", "like", " ", "binomial", " ", "for", " ", 
     "NonCommutativeMultiply"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"expanded", "=", 
   RowBox[{"QAPowerContract", "[", 
    RowBox[{"QAPowerExpand", "[", "power", "]"}], "]"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->252354604],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["A", "^"], "\[CenterDot]", 
   SuperscriptBox[
    OverscriptBox["B", "^"], "2"]}], "+", 
  RowBox[{
   SuperscriptBox[
    OverscriptBox["A", "^"], "2"], "\[CenterDot]", 
   OverscriptBox["B", "^"]}], "+", 
  RowBox[{
   OverscriptBox["B", "^"], "\[CenterDot]", 
   SuperscriptBox[
    OverscriptBox["A", "^"], "2"]}], "+", 
  RowBox[{
   SuperscriptBox[
    OverscriptBox["B", "^"], "2"], "\[CenterDot]", 
   OverscriptBox["A", "^"]}], "+", 
  RowBox[{
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["A", "^"]}], "+", 
  RowBox[{
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["B", "^"]}], "+", 
  SuperscriptBox[
   OverscriptBox["A", "^"], "3"], "+", 
  SuperscriptBox[
   OverscriptBox["B", "^"], "3"]}]], "Output",
 ImageSize->{331, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->823057245]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Operator"]],"paclet:QuantumAlgebra/ref/Operator"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAPowerContract"]],"paclet:QuantumAlgebra/ref/QAPowerContract"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAPowerExpand",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 1.9270842}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"Operator QAPowerContract QAPowerExpand"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAPowerExpand[expr] expands all powers in expr as non-commutative \
products.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "QAPowerExpand", 
    "titlemodifier" -> "", "windowtitle" -> "QAPowerExpand", "type" -> 
    "Symbol", "uri" -> "QuantumAlgebra/ref/QAPowerExpand"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4478, 126, 386, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->34501765]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13401, 414}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 3172, 75, 50, "AnchorBarGrid",
 CellID->1],
Cell[3760, 98, 290, 11, 44, "ObjectNameGrid"],
Cell[4053, 111, 400, 11, 80, "Usage"],
Cell[CellGroupData[{
Cell[4478, 126, 386, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->34501765],
Cell[CellGroupData[{
Cell[4889, 145, 195, 6, 25, "ExampleSection",
 CellID->180032573],
Cell[CellGroupData[{
Cell[5109, 155, 239, 7, 43, "Input",
 CellID->144071775],
Cell[CellGroupData[{
Cell[5373, 166, 144, 2, 22, "Print",
 CellID->275869943],
Cell[5520, 170, 154, 3, 22, "Print",
 CellID->257456957],
Cell[5677, 175, 159, 3, 22, "Print",
 CellID->319816467],
Cell[5839, 180, 161, 3, 22, "Print",
 CellID->940176453]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6049, 189, 292, 10, 46, "Input",
 CellID->130503262],
Cell[6344, 201, 226, 8, 39, "Output",
 CellID->323852225]
}, Open  ]],
Cell[CellGroupData[{
Cell[6607, 214, 256, 8, 43, "Input",
 CellID->659622813],
Cell[6866, 224, 276, 10, 43, "Output",
 CellID->1029824]
}, Open  ]],
Cell[CellGroupData[{
Cell[7179, 239, 534, 14, 59, "Input",
 CellID->252354604],
Cell[7716, 255, 1023, 34, 39, "Output",
 CellID->823057245]
}, Open  ]]
}, Open  ]],
Cell[8766, 293, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8834, 298, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[9107, 312, 570, 16, 58, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[9692, 331, 23, 0, 70, "FooterCell"]
}
]
*)

