(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17661,        542]
NotebookOptionsPosition[     12005,        390]
NotebookOutlinePosition[     16120,        486]
CellTagsIndexPosition[     16035,        481]
WindowTitle->QASetIndexCharacter
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QASelectDefault\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QASelectDefault"], "\<\"QAGetIndexCharacter\
\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAGetIndexCharacter"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QASetIndexCharacter\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QASetIndexCharacter"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QASetIndexCharacter.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$39431], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QASetIndexCharacter", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QASetIndexCharacter", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QASetIndexCharacter", "[", 
       RowBox[{
        StyleBox["character", "TI"], ",", " ", 
        StyleBox["set", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]defines the Index Character to be used throughout a \
calculation. Per default the character is assigned to the default set. The \
default character (if not defined) is \"Mixed\"."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->301129055],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
The character must be a List of a string and a further List of symbol names. \
The string names the character and must be one of \"Mixed\", \"Covariant\", \
\"Contravariant\". The symbol names are those to which the character is to be \
assigned. \"Mixed\" has no assigned symbols, all symbols are treated \
\"Mixed\" in this case.\
\>", "Notes",
 CellID->1067943069],

Cell["The meaning of the character names is as follows: ", "Notes",
 CellID->431520387],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"Mixed\"\>", "Notes"], 
     StyleBox["\<\"All indexed symbols are used 'as is' and their index \
position is preserved during calculation\"\>", "Notes"]},
    {
     StyleBox["\<\"Covariant\"\>", "Notes"], 
     StyleBox["\<\"If a Contravariant version of a defined symbol is found, \
it is transformed to the Covariant version\"\>", "Notes"]},
    {
     StyleBox["\<\"Contravariant\"\>", "Notes"], 
     StyleBox["\<\"If a Covariant version of a defined symbol is found, it is \
transformed to the Contravariant version\"\>", "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output"]], "Notes",
 CellID->334308025]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->99624622],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->306433082],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "QuantumAlgebra`"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->216584976],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->303841932],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->295286966],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->224825805],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->620988034]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Declare", " ", "a", " ", "name", " ", "for", " ", "a", " ", "set", " ", 
    "of", " ", "assumptions"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"QASelectDefault", "[", "\"\<KleinGordon\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Define", " ", "the", " ", "Index", " ", "Character", " ", "in", " ", 
     "the", " ", "calculated", " ", "expressions"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QASetIndexCharacter", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<Contravariant\>\"", ",", 
       RowBox[{"{", "k", "}"}]}], "}"}], "]"}], ";"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->325804111],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "We", " ", "define", " ", "the", " ", "exponent", " ", "of", " ", "a", " ",
     "plane", " ", "wave", " ", "solution", " ", "here"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"exp", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        SubscriptBox["k", "i"], " ", 
        SuperscriptBox["x", "i"]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}]}], 
    "]"}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->439963557],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Output", " ", 
    RowBox[{"shows", ":", " ", 
     RowBox[{
     "automatic", " ", "transformation", " ", "of", " ", "the", " ", "wave", 
      " ", "numbers", " ", 
      RowBox[{"to", " ", "'"}], 
      RowBox[{"Contravariant", "'"}], " ", "index", " ", "character", " ", 
      "is", " ", "performed"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "exp"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->49816399],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["k", "0"], " ", 
   SuperscriptBox["x", "0"]}], "-", 
  RowBox[{
   SuperscriptBox["k", "1"], " ", 
   SuperscriptBox["x", "1"]}], "-", 
  RowBox[{
   SuperscriptBox["k", "2"], " ", 
   SuperscriptBox["x", "2"]}], "-", 
  RowBox[{
   SuperscriptBox["k", "3"], " ", 
   SuperscriptBox["x", "3"]}]}]], "Output",
 ImageSize->{159, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->247373318]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QASelectDefault"]],"paclet:QuantumAlgebra/ref/QASelectDefault"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAGetIndexCharacter"]],
    "paclet:QuantumAlgebra/ref/QAGetIndexCharacter"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QASetIndexCharacter",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 21.1457123}", 
    "history" -> {"2.1.1", "", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", 
    "keywords" -> {"QASetIndexCharacter QAGetIndexCharacter QASelectDefault"},
     "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> 
    True, "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QASetIndexCharacter[character, set] defines the Index Character to be \
used throughout a calculation. Per default the character is assigned to the \
default set. The default character (if not defined) is \"Mixed\".", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "QASetIndexCharacter", 
    "titlemodifier" -> "", "windowtitle" -> "QASetIndexCharacter", "type" -> 
    "Symbol", "uri" -> "QuantumAlgebra/ref/QASetIndexCharacter"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7084, 204, 386, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->99624622]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15893, 474}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 3252, 79, 50, "AnchorBarGrid",
 CellID->1],
Cell[3846, 102, 296, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4167, 117, 596, 15, 96, "Usage"],
Cell[CellGroupData[{
Cell[4788, 136, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->301129055],
Cell[5529, 162, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5563, 164, 377, 7, 70, "Notes",
 CellID->1067943069],
Cell[5943, 173, 87, 1, 70, "Notes",
 CellID->431520387],
Cell[6033, 176, 1002, 22, 70, "Notes",
 CellID->334308025]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7084, 204, 386, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->99624622],
Cell[CellGroupData[{
Cell[7495, 223, 195, 6, 25, "ExampleSection",
 CellID->306433082],
Cell[CellGroupData[{
Cell[7715, 233, 231, 7, 43, "Input",
 CellID->216584976],
Cell[CellGroupData[{
Cell[7971, 244, 144, 2, 22, "Print",
 CellID->303841932],
Cell[8118, 248, 154, 3, 22, "Print",
 CellID->295286966],
Cell[8275, 253, 159, 3, 22, "Print",
 CellID->224825805],
Cell[8437, 258, 161, 3, 22, "Print",
 CellID->620988034]
}, Open  ]]
}, Open  ]],
Cell[8625, 265, 761, 21, 75, "Input",
 CellID->325804111],
Cell[9389, 288, 618, 20, 48, "Input",
 CellID->439963557],
Cell[CellGroupData[{
Cell[10032, 312, 469, 13, 59, "Input",
 CellID->49816399],
Cell[10504, 327, 493, 18, 37, "Output",
 CellID->247373318]
}, Open  ]]
}, Open  ]],
Cell[11024, 349, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11092, 354, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[11365, 368, 598, 17, 58, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[11978, 388, 23, 0, 70, "FooterCell"]
}
]
*)

