(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16091,        504]
NotebookOptionsPosition[     10520,        353]
NotebookOutlinePosition[     14585,        448]
CellTagsIndexPosition[     14500,        443]
WindowTitle->QASubsuperscript
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QASimplescript\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/QASimplescript"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QASubsuperscript\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QASubsuperscript"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QASubsuperscript.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$42687], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QASubsuperscript", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QASubsuperscript", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QASubsuperscript", "[", 
       RowBox[{
        StyleBox["symbol", "TI"], ",", " ", 
        RowBox[{"{", 
         StyleBox["lower", "TI"], "}"}], ",", " ", 
        RowBox[{"{", 
         StyleBox["upper", "TI"], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]supports a sophisticated script notation with lower \
and/or upper indices. The indices themselves can be integers, simple symbols \
or simple scripted symbols."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->425767208],

Cell["", "SectionHeaderSpacer"],

Cell["The parameters are as follows:", "Notes",
 CellID->1067943069],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"symbol\"\>", "Notes"], 
     StyleBox["\<\"The symbol\"\>", "Notes"]},
    {
     StyleBox["\<\"{lower}\"\>", "Notes"], 
     StyleBox["\<\"A list of lower indices, can be empty\"\>", "Notes"]},
    {
     StyleBox["\<\"{upper}\"\>", "Notes"], 
     StyleBox["\<\"A list of upper indices, can be empty\"\>", "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output"]], "Notes",
 CellID->96055901]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->293476787],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->8082781],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "QuantumAlgebra`"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->216584976],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->303841932],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->295286966],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->224825805],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->620988034]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defines", " ", "a", " ", "scripted", " ", "symbol", " ", 
    "\[IndentingNewLine]", 
    RowBox[{"Here", ":", " ", 
     RowBox[{"a", " ", "polarization", " ", "vector"}]}]}], 
   "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"eps", "=", 
   SubsuperscriptBox["\[Epsilon]", 
    RowBox[{
     SubscriptBox["k", "1"], ",", 
     SubscriptBox["k", "2"], ",", 
     SubscriptBox["k", "3"]}], 
    RowBox[{"i", ",", "r"}]]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->641895662],

Cell[BoxData[
 SubsuperscriptBox["\[Epsilon]", 
  RowBox[{
   SubscriptBox["k", "1"], ",", 
   SubscriptBox["k", "2"], ",", 
   SubscriptBox["k", "3"]}], 
  RowBox[{"i", ",", "r"}]]], "Output",
 ImageSize->{55, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->12922929]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"The", " ", "FullForm", " ", "of", " ", "this", " ", "symbol"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"eps", "//", "FullForm"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->53667640],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"QASubsuperscript", "[", 
    RowBox[{"\[Epsilon]", ",", 
     RowBox[{"List", "[", 
      RowBox[{
       RowBox[{"QASimplescript", "[", 
        RowBox[{"k", ",", "1", ",", "False"}], "]"}], ",", 
       RowBox[{"QASimplescript", "[", 
        RowBox[{"k", ",", "2", ",", "False"}], "]"}], ",", 
       RowBox[{"QASimplescript", "[", 
        RowBox[{"k", ",", "3", ",", "False"}], "]"}]}], "]"}], ",", 
     RowBox[{"List", "[", 
      RowBox[{"i", ",", "r"}], "]"}]}], "]"}],
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 ImageSize->{488, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//FullForm=",
 CellID->400410333]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QASimplescript"]],"paclet:QuantumAlgebra/ref/QASimplescript"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QASubsuperscript",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 32.3567307}", 
    "history" -> {"2.1.1", "", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", 
    "keywords" -> {"QASimplescript QASubsuperscript"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QASubsuperscript[symbol, {lower}, {upper}] supports a sophisticated \
script notation with lower and/or upper indices. The indices themselves can \
be integers, simple symbols or simple scripted symbols.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "QASubsuperscript", "titlemodifier" -> "", 
    "windowtitle" -> "QASubsuperscript", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QASubsuperscript"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6377, 190, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->293476787]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 14357, 436}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[588, 21, 3090, 74, 50, "AnchorBarGrid",
 CellID->1],
Cell[3681, 97, 293, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[3999, 112, 677, 18, 94, "Usage"],
Cell[CellGroupData[{
Cell[4701, 134, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->425767208],
Cell[5442, 160, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5476, 162, 68, 1, 70, "Notes",
 CellID->1067943069],
Cell[5547, 165, 781, 19, 70, "Notes",
 CellID->96055901]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6377, 190, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->293476787],
Cell[CellGroupData[{
Cell[6789, 209, 193, 6, 25, "ExampleSection",
 CellID->8082781],
Cell[CellGroupData[{
Cell[7007, 219, 231, 7, 43, "Input",
 CellID->216584976],
Cell[CellGroupData[{
Cell[7263, 230, 144, 2, 22, "Print",
 CellID->303841932],
Cell[7410, 234, 154, 3, 22, "Print",
 CellID->295286966],
Cell[7567, 239, 159, 3, 22, "Print",
 CellID->224825805],
Cell[7729, 244, 161, 3, 22, "Print",
 CellID->620988034]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7939, 253, 558, 17, 82, "Input",
 CellID->641895662],
Cell[8500, 272, 322, 11, 44, "Output",
 CellID->12922929]
}, Open  ]],
Cell[CellGroupData[{
Cell[8859, 288, 253, 7, 43, "Input",
 CellID->53667640],
Cell[9115, 297, 744, 22, 66, "Output",
 CellID->400410333]
}, Open  ]]
}, Open  ]],
Cell[9886, 323, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9954, 328, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[10227, 342, 251, 6, 58, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[10493, 351, 23, 0, 70, "FooterCell"]
}
]
*)

