(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20441,        672]
NotebookOptionsPosition[     14347,        498]
NotebookOutlinePosition[     18385,        594]
CellTagsIndexPosition[     18300,        589]
WindowTitle->QuantumExpressionQ
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Analyze\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Analyze"], "\<\"BraExpressionQ\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/BraExpressionQ"], "\<\"KetExpressionQ\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/KetExpressionQ"], \
"\<\"OperatorExpressionQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/OperatorExpressionQ"], \
"\<\"QuantumConstantExpressionQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QuantumConstantExpressionQ"], \
"\<\"QuantumFreeQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QuantumFreeQ"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QuantumExpressionQ\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QuantumExpressionQ"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QuantumExpressionQ.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$44729], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QuantumExpressionQ", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QuantumExpressionQ", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QuantumExpressionQ", "[", 
       StyleBox["ex", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]tests if expression ex is a well formed Quantum \
expression."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->518368768],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
It must be one of the concrete Quantum types Bra, Ket, Operator, \
QuantumConstant\
\>", "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->15575595],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->203149523],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->123008308],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->184744939],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->712346438],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->214280970],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->339305153]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Define", " ", "some", " ", "valid", " ", "expressions", " ", "and", " ", 
    "one", " ", "malformed"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ket", "=", 
   RowBox[{
    TagBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0.}, {0, 0}}], 
      AdjustmentBox[
       TagBox["Q",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}],
     QuantumAlgebra`Ket,
     BaseStyle->"KetWrapper"], "+", 
    TagBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0.}, {0, 0}}], 
      AdjustmentBox[
       TagBox["R",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}],
     QuantumAlgebra`Ket,
     BaseStyle->"KetWrapper"]}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->131300084],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["Q",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"], "+", 
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["R",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"]}]], "Output",
 ImageSize->{65, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->482446678]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"op", "=", 
  RowBox[{
   RowBox[{
    OverscriptBox["A", "^"], "\[CenterDot]", 
    SuperscriptBox[
     OverscriptBox["B", "^"], "\[Dagger]"]}], " ", "Pi"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->25365821],

Cell[BoxData[
 RowBox[{"\[Pi]", " ", 
  RowBox[{
   OverscriptBox["A", "^"], "\[CenterDot]", 
   SuperscriptBox[
    OverscriptBox["B", "^"], "\[Dagger]"]}]}]], "Output",
 ImageSize->{46, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->148407823]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"invalid", "=", 
  RowBox[{
   TagBox[
    RowBox[{
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{-0.4, 0.}, {0, 0}}], 
     AdjustmentBox[
      TagBox["Q",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], "\[RightAngleBracket]"}],
    QuantumAlgebra`Ket,
    BaseStyle->"KetWrapper"], "+", 
   OverscriptBox["X", "^"]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->386769644],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["Q",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"], "+", 
  OverscriptBox["X", "^"]}]], "Output",
 ImageSize->{48, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->3131282]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Check", " ", "them"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QuantumExpressionQ", "[", "ket", "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->279687174],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->4141272]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QuantumExpressionQ", "[", "op", "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->94195362],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->39817422]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QuantumExpressionQ", "[", "invalid", "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->17894548],

Cell[BoxData["False"], "Output",
 ImageSize->{39, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->156573592]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Analyze"]],"paclet:QuantumAlgebra/ref/Analyze"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["BraExpressionQ"]],"paclet:QuantumAlgebra/ref/BraExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["KetExpressionQ"]],"paclet:QuantumAlgebra/ref/KetExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OperatorExpressionQ"]],
    "paclet:QuantumAlgebra/ref/OperatorExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QuantumConstantExpressionQ"]],
    "paclet:QuantumAlgebra/ref/QuantumConstantExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QuantumFreeQ"]],"paclet:QuantumAlgebra/ref/QuantumFreeQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->22987728]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QuantumExpressionQ",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 39.6861351}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> 
    "QuantumAlgebra`Analyze`", 
    "keywords" -> {
     "Analyze BraExpressionQ KetExpressionQ OperatorExpressionQ \
QuantumConstantExpressionQ QuantumFreeQ QuantumExpressionQ"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QuantumExpressionQ[ex] tests if expression ex is a well formed Quantum \
expression.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QuantumExpressionQ", "titlemodifier" -> "", "windowtitle" -> 
    "QuantumExpressionQ", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QuantumExpressionQ"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5979, 178, 386, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->15575595]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18158, 582}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 3680, 86, 50, "AnchorBarGrid",
 CellID->1],
Cell[4273, 109, 295, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4593, 124, 409, 12, 80, "Usage"],
Cell[CellGroupData[{
Cell[5027, 140, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->518368768],
Cell[5768, 166, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5802, 168, 128, 4, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5979, 178, 386, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->15575595],
Cell[CellGroupData[{
Cell[6390, 197, 195, 6, 25, "ExampleSection",
 CellID->203149523],
Cell[CellGroupData[{
Cell[6610, 207, 239, 7, 43, "Input",
 CellID->123008308],
Cell[CellGroupData[{
Cell[6874, 218, 144, 2, 22, "Print",
 CellID->184744939],
Cell[7021, 222, 154, 3, 22, "Print",
 CellID->712346438],
Cell[7178, 227, 159, 3, 22, "Print",
 CellID->214280970],
Cell[7340, 232, 161, 3, 22, "Print",
 CellID->339305153]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7550, 241, 993, 31, 44, "Input",
 CellID->131300084],
Cell[8546, 274, 818, 28, 37, "Output",
 CellID->482446678]
}, Open  ]],
Cell[CellGroupData[{
Cell[9401, 307, 236, 8, 30, "Input",
 CellID->25365821],
Cell[9640, 317, 300, 10, 39, "Output",
 CellID->148407823]
}, Open  ]],
Cell[CellGroupData[{
Cell[9977, 332, 475, 16, 32, "Input",
 CellID->386769644],
Cell[10455, 350, 520, 18, 41, "Output",
 CellID->3131282]
}, Open  ]],
Cell[CellGroupData[{
Cell[11012, 373, 223, 6, 43, "Input",
 CellID->279687174],
Cell[11238, 381, 159, 5, 35, "Output",
 CellID->4141272]
}, Open  ]],
Cell[CellGroupData[{
Cell[11434, 391, 114, 3, 26, "Input",
 CellID->94195362],
Cell[11551, 396, 160, 5, 35, "Output",
 CellID->39817422]
}, Open  ]],
Cell[CellGroupData[{
Cell[11748, 406, 119, 3, 70, "Input",
 CellID->17894548],
Cell[11870, 411, 162, 5, 35, "Output",
 CellID->156573592]
}, Open  ]]
}, Open  ]],
Cell[12059, 420, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12127, 425, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[12400, 439, 1905, 54, 70, "SeeAlso",
 CellID->22987728]
}, Open  ]],
Cell[14320, 496, 23, 0, 70, "FooterCell"]
}
]
*)

